function openNewWindow(URL, title, width, height){
        if (!width){
            width = 1000;
        }
        if (!height){
            height = 600;
        }
	window.open(URL,title,'location=no,menubar=no,toolbar=no,resizable=no,scrollbars=yes,width=' + width + ',height=' + height);
}


function openSuggestion(closeSuggestion){
    
    if (closeSuggestion == 1){
        //renunta
        document.getElementById("suggestion_form").style.display = 'none';
        document.getElementById('suggestionDescription').value   = '';
    } else {
        //dislay form suggestion
        document.getElementById("suggestion_form").style.display = 'block';
        document.getElementById('suggestionDescription').focus();    
    }
}


function sendSuggestion(description, root){
      var xmlHttp;
      try{
        // Firefox, Opera 8.0+, Safari
        xmlHttp=new XMLHttpRequest();
      }catch (e){
        // Internet Explorer
        try{
          xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
        }catch (e){
          try{
            xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
          }catch (e){
              alert("Browser-ul dumneavoastra nu suporta AJAX!");
             //alert("Your browser does not support AJAX!");
            return false;
          }
        }
     }
     
    xmlHttp.onreadystatechange=function(){
      if(xmlHttp.readyState==4){
        //hide the element
        document.getElementById("messages_suggestion").style.display = 'block';
        document.getElementById("messages_suggestion").innerHTML     = xmlHttp.responseText;
        document.getElementById('suggestionDescription').value       = '';
        document.getElementById('suggestionDescription').focus();
      }//if
    }//fct
    
    //alert("hey: " + description);

    xmlHttp.open("GET", root + "/common/sendSuggestion.jsp?description=" + description, true);
    xmlHttp.send(null);
}


function calculatePrice(tvaValue){
    var noOfCredits  = document.getElementById('noOfCredits').value;
    var priceField = document.getElementById('price');
    var tvaField   = document.getElementById('tva');
    var sumField   = document.getElementById('sum'); //total
    
    
    //check to see if the given noOfCredits is valid number
    if ((noOfCredits > 0) && !isNaN(noOfCredits)){
        //price    
        var price = noOfCredits;
        priceField.value = price;
    

        //tva for price
        var tva = price * (tvaValue/100);
        tvaField.value   = tva;

        //sum (price + tva from price)
        var sum = parseInt(price) + tva;
        sumField.value = sum;
    }else{
        priceField.value = '';
        tvaField.value   = '';
        sumField.value   = '';
    }
}

function verifySubmitClientReport(){
    //client
    var clientIdSelect = document.getElementById('clientId');
    var clientId = clientIdSelect.options[clientIdSelect.selectedIndex].value;
    
    //perioada
    var periodSelect = document.getElementById('period');
    var period = periodSelect.options[periodSelect.selectedIndex].value;
    
    //srat & end
    var start = document.getElementById("periodStart").value;
    var end = document.getElementById("periodEnd").value;
    
    var errorMessage = "";
    if (clientId == 0){
        errorMessage += "Selectati un client. \n";
    }

    //validari date
    if (period == 0 && (start == "" && end == "")){
        errorMessage += "Selectati perioada sau alegeti un interval pentru care sa afisati raportul. \n";
        
    }else if(period == 0 && (start == "" || end == "")){
        errorMessage += "Daca nu selectati o perioada atunci trebuie sa introduceti ambele date: 'De la' si 'Pana la'. \n";
        
    }else{
        if (!isNaN(Date.parse(start)) && !isNaN(Date.parse(end))){
            if (Date.parse(start) > Date.parse(end)){
                errorMessage += "Data de inceput trebuie sa fie inaintea datei de sfarsit. \n";
            }
        }else{
                errorMessage += "Datele trebuie sa aiba formatul specificat. \n";
        }
    }
   
   //diaply errors
   if (errorMessage != ""){
       errorMessage += "\nToate campurile marcate cu * sunt obligatorii!"
       alert(errorMessage);
       return false;
   }
   
   
   return true;
}//fct


function verifySubmitProjectReport(){
    //project
    var projectIdSelect = document.getElementById('projectId');
    var projectId = projectIdSelect.options[projectIdSelect.selectedIndex].value;
    
    //perioada
    var periodSelect = document.getElementById('period');
    var period = periodSelect.options[periodSelect.selectedIndex].value;
    
    //srat & end
    var start = document.getElementById("periodStart").value;
    var end = document.getElementById("periodEnd").value;
    
    var errorMessage = "";
    if (projectId == 0){
        errorMessage += "Selectati un proiect. \n";
    }

    //validari date
    if (period == 0 && (start == "" && end == "")){
        errorMessage += "Selectati perioada sau alegeti un interval pentru care sa afisati raportul. \n";
        
    }else if(period == 0 && (start == "" || end == "")){
        errorMessage += "Daca nu selectati o perioada atunci trebuie sa introduceti ambele date: 'De la' si 'Pana la'. \n";
        
    }else{
        if (!isNaN(Date.parse(start)) && !isNaN(Date.parse(end))){
            if (Date.parse(start) > Date.parse(end)){
                errorMessage += "Data de inceput trebuie sa fie inaintea datei de sfarsit. \n";
            }
        }else{
                errorMessage += "Datele trebuie sa aiba formatul specificat. \n";
        }
    }
   
   //diaply errors
   if (errorMessage != ""){
       errorMessage += "\nToate campurile marcate cu * sunt obligatorii!"
       alert(errorMessage);
       return false;
   }
   
   
   return true;
}//fct


function verifySubmitEmployeeReport(){
    //employee
    var employeeIdSelect = document.getElementById('employeeId');
    var employeeId = employeeIdSelect.options[employeeIdSelect.selectedIndex].value;
    
    //perioada
    var periodSelect = document.getElementById('period');
    var period = periodSelect.options[periodSelect.selectedIndex].value;
    
    //srat & end
    var start = document.getElementById("periodStart").value;
    var end = document.getElementById("periodEnd").value;
    
    var errorMessage = "";
    if (employeeId == 0){
        errorMessage += "Selectati un angajat. \n";
    }
    
    //validari date
    if (period == 0 && (start == "" && end == "")){
        errorMessage += "Selectati perioada sau alegeti un interval pentru care sa afisati raportul. \n";
        
    }else if(period == 0 && (start == "" || end == "")){
        errorMessage += "Daca nu selectati o perioada atunci trebuie sa introduceti ambele date: 'De la' si 'Pana la'. \n";
        
    }else{
        if (!isNaN(Date.parse(start)) && !isNaN(Date.parse(end))){
            if (Date.parse(start) > Date.parse(end)){
                errorMessage += "Data de inceput trebuie sa fie inaintea datei de sfarsit. \n";
            }
        }else{
                errorMessage += "Datele trebuie sa aiba formatul specificat. \n";
        }
    }
   
   //diaply errors
   if (errorMessage != ""){
       errorMessage += "\nToate campurile marcate cu * sunt obligatorii!"
       alert(errorMessage);
       return false;
   }
   
   
   return true;
}//fct


function verifySubmitAllEmployeesReport(){
    //perioada
    var periodSelect = document.getElementById('period');
    var period = periodSelect.options[periodSelect.selectedIndex].value;
    
    //srat & end
    var start = document.getElementById("periodStart").value;
    var end = document.getElementById("periodEnd").value;
    
    var errorMessage = "";
    
    //validari date
    if (period == 0 && (start == "" && end == "")){
        errorMessage += "Selectati perioada sau alegeti un interval pentru care sa afisati raportul. \n";
        
    }else if(period == 0 && (start == "" || end == "")){
        errorMessage += "Daca nu selectati o perioada atunci trebuie sa introduceti ambele date: 'De la' si 'Pana la'. \n";
        
    }else{
        if (!isNaN(Date.parse(start)) && !isNaN(Date.parse(end))){
            if (Date.parse(start) > Date.parse(end)){
                errorMessage += "Data de inceput trebuie sa fie inaintea datei de sfarsit. \n";
            }
        }else{
                errorMessage += "Datele trebuie sa aiba formatul specificat. \n";
        }
    }
   
   //diaply errors
   if (errorMessage != ""){
       errorMessage += "\nToate campurile marcate cu * sunt obligatorii!"
       alert(errorMessage);
       return false;
   }
   
   
   return true;
}//fct

