<?php
$currentFolder = dirname(__FILE__);
require_once ($currentFolder . "/delegate.php");

// Start the session
session_start();

$action = $_REQUEST['action'];

switch ($action) {

	/******************************LOGIN********************************/
	case 'goToUserLoginPage' :
		goToUserLoginPage();
		break;

	case 'doLoginExe' :
		doUserLoginExe();
		break;

	case 'doLogoutExe' :
		doLogoutExe();
		break;

	/******************************ANOTHERS*****************************/
	case 'doForgotPasswordExe' :
		doForgotPasswordExe();
		break;

	/******************************DAILY********************************/
	case 'goToDaily' :
		goToDaily();
		break;

	case 'doAddEntryExe' :
		doAddEntryExe();
		break;

	case 'doDeleteEntryExe' :
		doDeleteEntryExe();
		break;

	case 'doChangeDailyCalendarExe' :
		doChangeDailyCalendarExe();
		break;

	case 'doContinueEntryExe' :
		doContinueEntryExe();
		break;

	/******************************MONTHLY******************************/
	case 'goToMonthly' :
		goToMonthly();
		break;

	case 'doChangeMonthlyCalendarExe' :
		doChangeMonthlyCalendarExe();
		break;

	/******************************PROJECTS*****************************/
	case 'goToProjects' :
		goToProjects();
		break;

	case 'doAddProjectExe' :
		doAddProjectExe();
		break;

	case 'doChangeProjectStatusExe' :
		doChangeProjectStatusExe();
		break;

	case 'doDeleteProjectExe' :
		doDeleteProjectExe();
		break;

	case 'goToEditProject' :
		goToEditProject();
		break;

	case 'doEditProjectExe' :
		doEditProjectExe();
		break;

	case 'doSetCurrentProjectExe' :
		doSetCurrentProjectExe();
		break;

	case 'doDisplayProjectReportExe' :
		doDisplayProjectReportExe();
		break;

	case 'doDisplayClientReportExe' :
		doDisplayClientReportExe();
		break;

	/******************************REPORTS******************************/
	case 'goToReports' :
		goToReports();
		break;

	case 'goToGeneralReports' :
		goToGeneralReports();
		break;

	case 'goToEmployeeReports';
		goToEmployeeReports();
		break;

	case 'goToProjectReports' :
		goToProjectReports();
		break;

	case 'goToClientReports' :
		goToClientReports();
		break;

	case 'doShowGeneralReportsExe' :
		doShowGeneralReportsExe();
		break;

	case 'doDisplayEmployeeReportExe' :
		doDisplayEmployeeReportExe();
		break;

	/******************************TASKS********************************/
	case 'doAddTaskExe' :
		doAddTaskExe();
		break;

	case 'doEditTaskExe' :
		doEditTaskExe();
		break;

	case 'doDeleteTaskByIdExe' :
		doDeleteTaskByIdExe();
		break;

	case 'goToEditTask' :
		goToEditTask();
		break;

	case 'doSetDefaultTaskExe' :
		doSetDefaultTaskExe();
		break;

	case 'doMoveTaskExe' :
		doMoveTaskExe();
		break;

	/******************************USERS********************************/
	case 'goToUsers' :
		goToUsers();
		break;

	case 'goToEditUser' :
		goToEditUser();
		break;

	case 'addUserExe' :
		addUserExe();
		break;

	case 'doChangeUserStatusExe' :
		doChangeUserStatusExe();
		break;

	case 'doDeleteUserExe' :
		doDeleteUserExe();
		break;

	case 'doEditUserExe' :
		doEditUserExe();
		break;

	case 'doAddUserInProjectExe' :
		doAddUserInProjectExe();
		break;

	case 'doDelteUserFromProjectExe' :
		doDelteUserFromProjectExe();
		break;

	case 'goToChangePassword' :
		goToChangePassword();
		break;

	case 'doChangePasswordExe' :
		doChangePasswordExe();
		break;

	/******************************CLIENTS******************************/
	case 'goToClients' :
		goToClients();
		break;

	case 'addClientExe' :
		addClientExe();
		break;

	case 'doDeleteClientExe' :
		doDeleteClientExe();
		break;

	case 'goToEditClient' :
		goToEditClient();
		break;

	case 'editClientExe' :
		editClientExe();
		break;

	/******************************ENTRIES******************************/
	case 'doFinishEntryExe' :
		doFinishEntryExe();
		break;

	case 'goToFinishEntry' :
		goToFinishEntry();

	case 'goToFinishEntry' :
		goToFinishEntry();
		break;

	case 'doCloseEntryExe' :
		doCloseEntryExe();
		break;

	case 'goToChangeEntryStatus' :
		goToChangeEntryStatus();
		break;

	case 'doChangeEntryStatusExe' :
		doChangeEntryStatusExe();
		break;

	/******************************ENTRIES******************************/
	case 'clientDoLoginExe' :
		clientDoLoginExe();
		break;

	case 'clientGetUserProjectsExe' :
		clientGetUserProjectsExe();
		break;

	case 'clientAddNewEntryExe' :
		clientAddNewEntryExe();
		break;

	case 'clientStartEntryExe' :
		clientStartEntryExe();
		break;

	case 'clientStopEntryExe' :
		clientStopEntryExe();
		break;

	case 'clientCheckUnfinishedTasksExe' :
		clientCheckUnfinishedTasksExe();
		break;

	/******************************SETTINGS******************************/
	case 'goToSettings' :
		goToSettings();
		break;

	case 'doAddLicenseFileExe' :
		doAddLicenseFileExe();
		break;

	case 'doChangeCompanyNameExe' :
		doChangeCompanyNameExe();
		break;

	case 'doChangeFirstDayOfWeek' :
		doChangeFirstDayOfWeek();
		break;

	/******************************CATCH ERRORS*************************/
	default :
		controllerErrors();
		break;

}

/**
 * Controller catch errors
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function controllerErrors() {
	print 'Unknown action: <b>' . $_REQUEST['action'] .'</b><br />';

	if(function_exists($_REQUEST['action'])) {
		print 'Function <b>' . $_REQUEST['action'] . '</b> exists!';
	} else {
		print 'Function <b>' . $_REQUEST['action'] . "</b> don't exists!";
	}
}

###################################################################################################
###   OTHER MOTHODS   #############################################################################

/**
 * Redirect to forget password
 * 
 * @author	Liviu
 * @since 	Apr 23, 2008
 */
function goToForgetPassword() {
	header('Location: ' . SERVER_ROOT . '/forgotPassword.php');
	exit ();
}



/**
 * Send password to user email
 * 
 * @author	Liviu
 * @since 	Apr 23, 2008
 */
function doForgotPasswordExe() {

	// Collect data
	$email = trim($_POST['email']);
	$securityCode = trim($_POST['securityCode']);
	$errors = false;

	// Check email
	if(empty($email)) {
		$_SESSION['errors'][] = 'Empty email';
		$errors = true;
	}

	// Check email synthax
	if(!empty($email) AND checkEmailSyntax($email) == false) {
		$_SESSION['errors'][] = 'Bad email synthax';
		$errors = true;
	}

	// Check security code
	if(empty($securityCode)) {
		$_SESSION['errors'][] = 'Empty security code';
		$errors = true;
	}

	if(!empty($securityCode) AND $_SESSION['secureCode'] != $securityCode) {
		$_SESSION['errors'][] = 'Bad security code';
		$errors = true;
	}

	// Check for errors
	if($errors) {
		return goToForgetPassword();

	// If no errors
	} else {

		// Make new Delegate instance		
		$delegate = new Delegate();

		// Get users by email address
		$users = $delegate->getUsers(array('email' => $email));

		// If exists one user with that email
		if(count($users) == 1) {

			// Get first user from array
			$user = $users[0];

			# TODO: Send email as plain/text and HTML too

			// HTML Version
			$bodyMessage = 'Hi <b>' . $user->name . "</b><br /><br />\n\n";
			$bodyMessage .= 'Your password for email account <b>' . $user->email . '</b> is: <b>' . $user->password . "<b><br /><br />\n\n";

			// If email was sended
			if(sendEmail($user->email, 'Recover password', $bodyMessage)) {
				$_SESSION['messages'][] = "Your password was successfully send to <b>{$user->email}</b><br />Please check your \"Bulk\" folder too";
				return goToUserLoginPage();

			// If not
			} else {
				$_SESSION['messages'][] = 'Error sending password! Please try again!';
				return goToForgetPassword();
			}

		// If no user with that email
		} else {
			$_SESSION['errors'][] = 'Inexistent email';
			return goToForgetPassword();
		}
	}

}



/**
 * User login 
 * @author	alex
 * @since 	Mar 26, 2008
 */
function doUserLoginExe() {
	$email		=	trim($_POST['email']);
	$pass		=	trim($_POST['password']);
	$remember	=	$_POST['remember'];

	$errors = false;

	// Check the email
	if(empty($email)) {
		$_SESSION['errors'][] = 'Empty email';
		$errors = true;
	}

	// Check the pass
	if(empty($pass)) {
		$_SESSION['errors'][] = 'Empty password';
		$errors = true;
	}

	// Check if exists errors
	if($errors) {
		return goToUserLoginPage();

	// If no errors
	} else {

		// Make new Delegate Object
		$delegate = new Delegate();

		// Get user ID by email and password
		$user = $delegate->getUserByEmailAndPassword($email, $pass);

		// User exists
		if($user->id) {
			$_SESSION['userId']		= $user->id;
			$_SESSION['messages'][]	= 'Succesfull login';

			if($remember) {
				$cookieDays = 3;
				setcookie('userId', $user->id, time() + (3600 * 24 * $cookieDays), '/');
				//setcookie("userId", $user->id, time()+3600, "/");
			}

			// Set up the callendar dates
			$_SESSION['calendarYear']	= date('Y');
			$_SESSION['calendarMonth']	= date('m');
			$_SESSION['calendarDay']	= date('j');

			return goToDaily();

		// User don't exists
		} else {
			$_SESSION['errors'][] = 'Wrong email or password';
			return goToUserLoginPage();
		}
	}
}



/**
 * Logout the user
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function doLogoutExe() {
	$_SESSION['userId'] = null;
	unset($_SESSION['userId']);
	setcookie('userId', $user->id, time() - 3600, '/');
	@ session_destroy;

	header('Location: ' . SERVER_ROOT . '/index.php');
}



/**
 * Redirect to user login page (not logged) 
 * @author	liviu
 */
function goToUserLoginPage() {
	header('Location: ' . SERVER_ROOT . '/index.php');
	exit ();
}



/**
 * Redirect to user home page (logged user)
 * @author	liviu
 */
function goToUserHomePage() {
	header('Location: ' . SERVER_ROOT . '/user/home.php');
	exit ();
}



/**
 * Redirects to Daily page
 * @author alex
*/
function goToDaily() {
	header('Location: ' . SERVER_ROOT . '/daily/daily.php');
	exit ();
}



/**
 * Add new entry
 * 
 * @author	Liviu
 * @since 	Apr 3, 2008
 */
function doAddEntryExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If user is logged
	if($loggedUser->level >= USER_LEVEL_USER) {

		$projectId		= $_POST['projectId'];
		$taskId			= $_POST['taskId'];
		$startTime		= trim($_POST['startTime']);
		$endTime		= trim($_POST['endTime']);
		$timeSpan		= trim($_POST['timeSpan']);
		$description	= trim($_POST['description']);
		$errors			= false;

		$calendarDay = (strlen($_SESSION['calendarDay']) == 1) ? '0' . $_SESSION['calendarDay'] : $_SESSION['calendarDay'];
		$calendarFullDate = $_SESSION['calendarYear'] . '-' . $_SESSION['calendarMonth'] . '-' . $calendarDay;

		$entryObject					= new Entry();
		$entryObject->date				= $calendarFullDate;
		$entryObject->startTime			= $startTime;
		$entryObject->endTime			= $endTime;
		$entryObject->description		= $description;
		$entryObject->checkDate			= date('Y-m-d H:i:s');
		$entryObject->checkDateIp		= $_SERVER['REMOTE_ADDR'];
		$entryObject->checkStartTime	= date('Y-m-d H:i:s');
		$entryObject->checkStartTimeIp	= $_SERVER['REMOTE_ADDR'];
		$entryObject->checkEndTime		= date('Y-m-d H:i:s');
		$entryObject->checkEndTimeIp	= $_SERVER['REMOTE_ADDR'];
		$entryObject->status			= ENTRY_STATUS_PENDING;
		$entryObject->statusDate		= date('Y-m-d H:i:s');
		$entryObject->projectId			= $projectId;
		$entryObject->userId			= $loggedUser->id;
		$entryObject->taskId			= (is_numeric($taskId)) ? $taskId : 'NULL';

		$_SESSION['tmpAddEntry'] = $entryObject;

		// Check if timespan is higher or equal with than 24:00
		if(!empty($timeSpan) AND checkTimeSpan($timeSpan)) {
			list($timeSpanHours, $timeSpanMinutes) = explode(':', $timeSpan);
			if($timeSpanHours * 60 + $timeSpanMinutes >= 1440) {
				$_SESSION['errors'][] = 'The time span is too higher!';
				return goToDaily();
			}
		}

		// Check project
		if(!is_numeric($projectId) AND $projectId <= 0) {
			$_SESSION['errors'][] = 'Empty project';
			return goToDaily();
		}

		// Check start time synthax
		if(!empty($startTime)) {
			if(checkTimeSpan($startTime) == false) {
				$_SESSION['errors'][] = 'Bad Start time format! Should be <b>hh:mm</b> (between 00:00 and 23:59)';
				return goToDaily();
			}
		}

		// Check end time synthax
		if(!empty($endTime)) {
			if(checkTimeSpan($endTime) == false) {
				$_SESSION['errors'][] = 'Bad End time format! Should be <b>hh:mm</b> (between 00:00 and 23:59)';
				return goToDaily();
			}
		}

		// Check if start time isn't
		// Get all entries for this day
		$entriesForThisDate = $delegate->getEntries(array('date' => $calendarFullDate));

		// For each loop
		foreach($entriesForThisDate as $entryKey => $entry) {

			// Increse
			$totalMinutesForThatDate += $entry->timeSpan;

			// If entry type isn't timespan
			if($entry->type != ENTRY_TYPE_TIMESPAN) {

				// If start/end time is between anothers entries
				if((strtotime($startTime) >= strtotime($entry->startTime) AND strtotime($startTime) < strtotime($entry->endTime)) 
					 OR (strtotime($endTime) > strtotime($entry->startTime) AND strtotime($endTime) < strtotime($entry->endTime)) 
					 OR ($entry->timeSpan == 0 AND strtotime($endTime) > strtotime($entry->startTime))) {
						$_SESSION['errors'][] = 'Start/End time is overlapping another entry!';
						return goToDaily();

				} else {
					continue;
				}

			// If entry type is timespan	
			} else {
				continue;
			}
		}

		// Check time span synthax
		if(!empty($timeSpan) AND checkTimeSpan($timeSpan) == false) {
			$_SESSION['errors'][] = 'Bad Time spam format! Should be <b>hh:mm</b> (between 00:01 and 23:59)';
			return goToDaily();
		}

		// Case 2
		if(empty($startTime) AND empty($endTime) AND checkTimeSpan($timeSpan)) {
			list($timeSpanHours, $timeSpanMinutes) = explode(':', $timeSpan);
			$timeSpan = $timeSpanHours * 60 + $timeSpanMinutes;
			$entryObject->timeSpan = $timeSpan;
		}
		
		// Case 3
		elseif(!empty($startTime) AND !empty($endTime) AND empty($timeSpan)) {
			$timeSpan = (strtotime($endTime) - strtotime($startTime)) / 60;
			$entryObject->timeSpan = (strtotime($endTime) - strtotime($startTime)) / 60;

		// Case 1
		} else {
			$timeSpan = 0;
			$entryObject->timeSpan = 0;
		}

		// If all entries is higher than 24H
		if($totalMinutesForThatDate >= 1440 OR ($totalMinutesForThatDate + $entryObject->timeSpan) >= 1441) {
			$_SESSION['errors'][] = 'All entries for current date are higher than 24 hours.<br />You can add maxim '. repairTimeSpan(floor((1440 - $totalMinutesForThatDate)/60) .':'. (1440 - $totalMinutesForThatDate)%60) .' hour(s) for this date!';
			return goToDaily();
		}


		// Check if user already have other enty opened
		$unfinishedEntries = $delegate->getUnfinishedEntriesForUser($loggedUser->id);

		// If logged user have unfinished entries
		if(is_array($unfinishedEntries) AND count($unfinishedEntries) > 0) {

			// If we have "both start and end time"
			if((!empty($startTime) AND !empty($endTime)) OR (!empty($timeSpan))) {
				$unfinishedEntryFullDate = $delegate->getUserUnfinishedEntryDate($loggedUser->id);
				list($unfinishedEntryDate, $unfinishedEntryTime) = explode(' ', $unfinishedEntryFullDate);

				// Case [1] : Unfinished entry date equal with current calendar date
				if(strtotime($unfinishedEntryDate) == strtotime($calendarFullDate)) {

					// If unfinished time is lower or equal with start time
					if(strtotime($unfinishedEntryTime) <= strtotime($startTime)) {
						$_SESSION['errors'][] = 'You already have an entry opened!';
						$errors = true;
					}

				// Case [2] : Unfinished entry date is higher than current calendar date
				} elseif(strtotime($unfinishedEntryDate) > strtotime($calendarFullDate)) {
					//exit("x");
					// TODO: WHAT?

				} else {
					$_SESSION['errors'][] = 'You already have an entry opened! (see bellow)';
					foreach($unfinishedEntries as $unfinishedEntrieKey => $unfinishedEntrie);

					list($_SESSION['calendarYear'], $_SESSION['calendarMonth'], $_SESSION['calendarDay']) = explode("-", $unfinishedEntrie->date);
					$errors = true;
				}

			} else {
				$_SESSION['errors'][] = 'You already have an entry opened! (see bellow)';
				$_SESSION['errors'][] = 'To add another entry for past time, you should complete both Start and Finished fields!';
				foreach($unfinishedEntries as $unfinishedEntrieKey => $unfinishedEntrie);

				list($_SESSION['calendarYear'], $_SESSION['calendarMonth'], $_SESSION['calendarDay']) = explode("-", $unfinishedEntrie->date);
				$errors = true;
			}
		}

		// Check projectId
		if(!is_numeric($projectId) OR $delegate->checkUserInProject($loggedUser->id, $projectId) == 0) {
			$_SESSION['errors'][] = 'Please select a project!';
			$errors = true;
		}

		// Get task by project id
		$tasks = $delegate->getTasks(array('projectid' => $projectId));
		
		if(is_array($tasks) AND count($tasks) > 0) {
			foreach($tasks as $taskKey => $task);
		}

		/*
		// Check taskId
		if(is_numeric($taskId) AND $task->projectId != $projectId) {
			$_SESSION['errors'][] = "Please select a task!";
			$errors = true;
		}
		*/

		// Check if we have start time OR timespan
		if(empty($startTime) AND empty($timeSpan)) {
			$_SESSION['errors'][] = 'Empty Start or Time span!';
			$errors = true;
		}

		// Check if end time are higher than start time
		if(!empty($startTime) AND !empty($endTime) AND strtotime($startTime) >= strtotime($endTime)) {
			$_SESSION['errors'][] = 'Finish time should be higher than start time!';
			$errors = true;
		}

		/*
		print strtotime($calendarFullDate);
		print '<br />'. strtotime(date("Y-m-d"));
		die();
		*/

		// Check if end date are higher than NOW()		
		if(strtotime($calendarFullDate) == strtotime(date('Y-m-d'))) {
			if(strtotime($startTime) > strtotime(date('H:i')) OR strtotime($endTime) > strtotime(date('H:i'))) {
				$_SESSION['errors'][] = 'Start time or end time is higher than present time!';
				$errors = true;
			}
			
		} elseif(strtotime($calendarFullDate) > strtotime(date('Y-m-d'))) {
			$_SESSION['errors'][] = 'Start time or end time is higher than present time!';
			$errors = true;
		}

		// Check for errors
		if($errors) {
			return goToDaily();

		// If no errors
		} else {

			unset($_SESSION['tmpAddEntry']);

			####################################################################
			###   CASE  / TYPE	1   ############################################
			/**
			 * We have only start time 
			 */

			if(!empty($startTime) AND empty($endTime) AND $timeSpan == 0) {
				$entryObject->type = ENTRY_TYPE_START_ONLY;
				if($delegate->addEntry($entryObject, ENTRY_TYPE_START_ONLY)) {
					$_SESSION['messages'][] = 'Entry successfully added!';
				} else {
					$_SESSION['errors'][] = 'Entry failed added!';
				}

				return goToDaily();

				####################################################################
				###   CASE  / TYPE	2   ############################################
				/**
				 * We have both start and end time 
				 */

			} elseif(!empty($startTime) AND !empty($endTime)) {
				$entryObject->type = ENTRY_TYPE_START_AND_FINISH;
				if($delegate->addEntry($entryObject, ENTRY_TYPE_START_AND_FINISH)) {
					$_SESSION['messages'][] = 'Entry successfully added!';
				} else {
					$_SESSION['errors'][] = 'Entry failed added!';
				}

				return goToDaily();

				####################################################################
				###   CASE  / TYPE	3   ############################################
				/**
				 * We have only time span
				 */

			} elseif(empty($startTime) AND empty($endTime) AND !empty($timeSpan)) {
				$entryObject->type = ENTRY_TYPE_TIMESPAN;
				if($delegate->addEntry($entryObject, ENTRY_TYPE_TIMESPAN)) {
					$_SESSION['messages'][] = 'Entry successfully added!';
				} else {
					$_SESSION['errors'][] = 'Entry failed added!';
				}

				return goToDaily();
			}
		}

		// If user isn't logged
	} else {
		return goToUserLoginPage();
	}
}



/**
 * Delete entry by id
 * 
 * @param	integer
 * @return	redirect
 * 
 * @author	Liviu
 * @since 	Apr 3, 2008
 */
function doDeleteEntryExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If user is logged
	if($loggedUser->level >= USER_LEVEL_USER) {

		// Collect data	
		$entryId = $_GET['entryId'];

		// Check entry id
		if(!is_numeric($entryId) AND $entryId <= 0) {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToDaily();
		}

		// Get entries by id and user id
		$entries = $delegate->getEntries(array('id'=> $entryId, 'userid' => $loggedUser->id));

		if(is_array($entries) AND count($entries) == 1) {
			foreach($entries as $entryKey => $entry);

			// If the entry was deleted	
			if($delegate->deleteEntryById($entry->id)) {
				$_SESSION['messages'][] = 'Entry successfully deleted!';

			// If not
			} else {
				$_SESSION['errors'][] = 'Entry failed deleted!';
			}

		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
		}

		return goToDaily();

	// If user isn't logged
	} else {
		return goToUserLoginPage();
	}
}



/**
 * Change calendar year, month and day, and save them in session
 * 
 * @author	Liviu
 * @since 	Apr 3, 2008
 */
function doChangeDailyCalendarExe() {
	$year	= $_GET['year'];
	$month	= $_GET['month'];
	$day	= $_GET['day'];

	if($month >= 13) {
		$month	= 1;
		$year	= $year +1;
	}

	if($month < 1) {
		$month	= 12;
		$year	= $year -1;
	}

	// Check data
	if(strtotime($year . '-' . $month . '-' . $day)) {

		/**
		 * Avoid dates like 31-february-2008 ;)
		 * 
		 * @author	Liviu
		 * @since 	Apr 22, 2008
		 */

		// Looping from 0 to 6 (7 times)
		for($i = 0; $i <= 6; $i++) {

			if(strlen($month) == 1) {
				$month = '0' . $month;
			}
			
			if(strlen($day) == 1) {
				$day = '0' . $day;
			}

			// If required date isn't the same with returned date by strtotime(), decrese day (-1) and continue the loop
			if($year . '-' . $month . '-' . $day != date('Y-m-d', strtotime($year . '-' . $month . '-' . $day))) {
				--$day;
				continue;

			// If required date is the same with returned date by strtotime(), break the loop
			} else {
				break;
			}
		}

		$_SESSION['calendarYear']	= $year;
		$_SESSION['calendarMonth']	= $month;
		$_SESSION['calendarDay']	= $day;

	} else {
		$_SESSION['calendarYear']	= date('Y');
		$_SESSION['calendarMonth']	= date('m');
		$_SESSION['calendarDay']	= date('j');
	}

	return goToDaily();
}



/**
 * Extend existent entry
 * 
 * @author	Liviu
 * @since 	Apr 7, 2008
 */
function doContinueEntryExe() {

	// Collect data
	$entryId = $_GET['entryId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Check if user already have other enty opened
	$unfinishedEntries = $delegate->getUnfinishedEntriesForUser($loggedUser->id);

	if(is_array($unfinishedEntries) AND count($unfinishedEntries) > 0) {
		$_SESSION['errors'][] = 'You already have an entry opened! (see bellow)';
		foreach($unfinishedEntries as $unfinishedEntrieKey => $unfinishedEntrie);

		list($_SESSION['calendarYear'], $_SESSION['calendarMonth'], $_SESSION['calendarDay']) = explode('-', $unfinishedEntrie->date);
		return goToDaily();
	}

	// [1] Check if entry id is numeric
	if(is_numeric($entryId) AND $entryId > 0) {
			
		// Get entry from DB by id and user logged id
		$entries = $delegate->getEntries(array('id' => $entryId, 'userid' => $loggedUser->id));

		// [2] Check if entries exists
		if(count($entries) == 1) {

			// For each loop
			foreach($entries as $entryKey => $entry);

			// Get all entries for this day
			$entriesForThisDate = $delegate->getEntries(array('date' => $entry->date));
	
			// For each loop
			foreach($entriesForThisDate as $entryKey => $entry) {
				// Increse
				$totalMinutesForThatDate += $entry->timeSpan;
			}
			
			// If all entries is higher than 24H
			if($totalMinutesForThatDate >= 1440) {
				$_SESSION['errors'][] = 'All entries for current date are higher than 24 hours.<br />You can add maxim '. repairTimeSpan(floor((1440 - $totalMinutesForThatDate)/60) .':'. (1440 - $totalMinutesForThatDate)%60) .' hour(s) for this date!';
				return goToDaily();
			}

			if($entry->status != ENTRY_STATUS_REJECTED) {

				// Setup
				$calendarDay = (strlen($_SESSION['calendarDay']) == 1) ? '0' . $_SESSION['calendarDay'] : $_SESSION['calendarDay'];
				$calendarFullDate = $_SESSION['calendarYear'] . '-' . $_SESSION['calendarMonth'] . '-' . $calendarDay;
				// Make new Entry instance
				$entryObject					= new Entry();
				$entryObject->date				= date('Y-m-d H:i:s');
				$entryObject->startTime			= date('H:i:s');
				$entryObject->description		= $entry->description;

				$entryObject->checkDate			= date('Y-m-d H:i:s');
				$entryObject->checkDateIp		= $_SERVER['REMOTE_ADDR'];
				$entryObject->checkStartTime	= date('Y-m-d H:i:s');
				$entryObject->checkStartTimeIp	= $_SERVER['REMOTE_ADDR'];
				$entryObject->checkEndTime		= date('Y-m-d H:i:s');
				$entryObject->checkEndTimeIp	= $_SERVER['REMOTE_ADDR'];
				$entryObject->status			= ENTRY_STATUS_PENDING;
				$entryObject->statusDate		= date('Y-m-d H:i:s');
				$entryObject->projectId			= $entry->projectId;
				$entryObject->userId			= $loggedUser->id;
				$entryObject->taskId			= (is_numeric($entry->taskId)) ? $entry->taskId : 'NULL';
				$entryObject->type				= ENTRY_TYPE_START_ONLY;

				if($delegate->addEntry($entryObject, ENTRY_TYPE_START_ONLY)) {
					$_SESSION['messages'][] = 'Entry successfully added!';

					$_SESSION['calendarYear']	= date('Y');
					$_SESSION['calendarMonth']	= date('m');
					$_SESSION['calendarDay']	= date('j');

				} else {
					$_SESSION['errors'][] = 'Entry failed added!';
				}

				return goToDaily();

			} else {
				return goToDaily();
			}

		// [2]
		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToDaily();
		}

	// [1]
	} else {
		// TODO: WHAT?
	}

}

###################################################################################################
###   MONTHLY   ###################################################################################


/**
 * Redirect to monthly page
 * 
 * @author	Liviu
 * @since 	Apr 7, 2008
 */
function goToMonthly() {
	header('Location: ' . SERVER_ROOT . '/monthly/monthly.php');
}



function doChangeMonthlyCalendarExe() {
	$year = $_GET['year'];
	$month = $_GET['month'];
	$day = $_GET['day'];

	if($month >= 13) {
		$month = 1;
		$year = $year +1;
	}

	if($month < 1) {
		$month = 12;
		$year = $year -1;
	}

	// Check data
	if(strtotime($year . '-' . $month . '-' . $day)) {
		$_SESSION['calendarYear'] = $year;
		$_SESSION['calendarMonth'] = $month;
		$_SESSION['calendarDay'] = $day;

	} else {
		$_SESSION['calendarYear'] = date('Y');
		$_SESSION['calendarMonth'] = date('m');
		$_SESSION['calendarDay'] = date('j');
	}

	return goToMonthly();
}

###################################################################################################
###   PROJECTS   ##################################################################################

/**
 * Redirect to projects page
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function goToProjects() {
	header('Location: ' . SERVER_ROOT . '/projects/projects.php');
	exit ();
}



function goToEditProject($projectId = null) {
	if($projectId == null) {
		$projectId = $_GET['projectId'];
	}

	header('Location: ' . SERVER_ROOT . "/projects/editproject.php?projectId={$projectId}");
	exit ();
}



/**
 * Add new project
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function doAddProjectExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		$name = trim($_POST['name']);
		$client = trim($_POST['clientId']);
		$includeMe = ($_POST['includeInProject'] == 'on') ? true : false;
		$errors = false;

		$project = new Project();
		$project->name = $name;
		$project->clientId = $client;

		// Get all projects from DB
		$projects = $delegate->getProjects();

		// Load and parse license as array()
		$licenseArrayContent = loadKey();

		// Check maxim numer of projects
		if(is_numeric($licenseArrayContent['MAX_PROJECTS']) AND $licenseArrayContent['MAX_PROJECTS'] > 0 AND count($projects) >= $licenseArrayContent['MAX_PROJECTS']) {
			$_SESSION['errors'][] = 'You have reached maximum projects number!';
			return goToProjects();
		}

		// Check for name
		if(empty($name)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty name!';
		}

		// Check if project name is already in use
		if(count($delegate->getProjects(array (
				'name' => $name
			))) > 0) {
			$errors = true;
			$_SESSION['errors'][] = 'That project name is already in use!';
		}

		if(is_numeric($client)) {
			// Get client by id
			$clients = $delegate->getClients($client);

			// Check if client exiss
			if(count($clients) != 1) {
				$errors = true;
				$_SESSION['errors'][] = 'Inexistent client!';
			}
		}

		// If errors
		if($errors) {
			return goToProjects();

			// If no errors
		} else {

			// Insert project
			$projectId = $delegate->addProject($project);

			// If project was addded
			if(is_numeric($projectId)) {

				$_SESSION['messages'][] = 'Project successfully added';

				// If user want to be asignet for this project
				if($includeMe) {

					// If user was added for this project
					if($delegate->addUserInProject($_SESSION['userId'], $projectId)) {
						$_SESSION['messages'][] = 'You have been successfully added on this project';

						// If not
					} else {
						$_SESSION['errors'][] = 'You have been added on this project';
					}
				}

				// If not
			} else {
				$_SESSION['errors'][] = 'Project failed added';
			}
		}

		return goToProjects();

		// If logged user isn't admin or super admin
	} else {
		return goToDaily();
	}
}



/**
 * Change project status (open to close, and reverse)
 * 
 * @author	Liviu
 * @since 	Apr 1, 2008
 */
function doChangeProjectStatusExe() {

	// Collect data
	$projectId = intval($_GET['projectId']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// If project id is numeric
		if(is_numeric($projectId)) {

			// Get projects by id
			$projects = $delegate->getProjects(array('id' => $projectId));

			// If is array
			if(is_array($projects)) {

				// Get current project status
				foreach($projects as $project);

				// If current status is "close", change him to "open"
				if($project->status == PROJECT_STATUS_CLOSE) {
					if($delegate->updateProjectStatusById($project->id, PROJECT_STATUS_OPEN)) {
						$_SESSION['messages'][] = 'Project successfully open!';
					} else {
						$_SESSION['errors'][] = "Can't change the project status!";
					}

				// Else if current status is "open", change him to "close"
				} elseif($project->status == PROJECT_STATUS_OPEN) {
					if($delegate->updateProjectStatusById($project->id, PROJECT_STATUS_CLOSE)) {
						
						// Set default project/task as null for all users who have that project as default
						$delegate->updateUserDefaultProjectAndTaskAsNull($projectId);
					
						$_SESSION['messages'][] = 'Project successfully close!';
					} else {
						$_SESSION['errors'][] = "Can't change the project status!";
					}
				}

				return goToProjects();

			// If not array
			} else {
				$_SESSION['errors'][] = "Project don't exists!";
				return goToProjects();
			}

		// If project id isn't numeric
		} else {
			$_SESSION['errors'][] = "Project don't exists!";
			return goToProjects();
		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Delete project by id
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doDeleteProjectExe() {

	// Collect data
	$projectId = intval($_GET['projectId']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// If project id is numeric
		if(is_numeric($projectId)) {

			// If project was deleted
			if($delegate->deleteProjectById($projectId)) {

				// Set default project/task as null for all users who have that project as default
				$delegate->updateUserDefaultProjectAndTaskAsNull($projectId);

				$_SESSION['messages'][] = 'Project successfully deleted!';

			// If not
			} else {
				$_SESSION['errors'][] = 'Project failed deleted!';
			}

			return goToProjects();

		// If project id isn't numeric	
		} else {
			$_SESSION['errors'][] = "Project don't exits!";
			return goToProjects();
		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Edit project
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doEditProjectExe() {
	$projectId = intval($_POST['projectId']);
	$projectName = trim($_POST['projectName']);
	$clientId = $_POST['clientId'];
	$errors = false;

	$project = new Project();
	$project->id = $projectId;
	$project->name = $projectName;
	$project->clientId = $clientId;

	// Check the name
	if(empty($projectName)) {
		$_SESSION['errors'][] = 'Empty name!';
		return goToEditProject($projectId);
	}

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// If project id is numeric
		if(!is_numeric($projectId)) {
			$_SESSION['errors'][] = "Project don't exists!";
			$errors = true;
		}

		// Check if that name is already in use
		if(count($delegate->getProjectsByNameAndUnverifiedId($projectName, $projectId)) > 0) {
			$_SESSION['errors'][] = 'That project name is already in use!';
			$errors = true;
			return goToEditProject($projectId);
		}

		// If errors
		if($errors) {
			return goToProjects();

		// If no errors
		} else {

			// If project was updated
			if($delegate->updateProject($project)) {
				$_SESSION['messages'][] = 'Project successfully updated!';
				return goToProjects();

			// If project wasn't updated
			} else {
				$_SESSION['errors'][] = 'Nothing to update';
				return goToEditProject($projectId);
			}

		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Set default project
 * 
 * @author	Liviu
 * @since 	Apr 1, 2008
 */
function doSetCurrentProjectExe() {

	// Collect data
	$projectId = $_GET['projectId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_USER) {

		// Check if project id is numeric
		if(is_numeric($projectId)) {

			// Get task and user by id
			$projects = $delegate->getProjects(array (
				'id' => $projectId
			));
			$users = $delegate->getUsers(array (
				'id' => $_SESSION['userId']
			));

			// Get user by id	
			if(is_array($users) AND count($users) == 1) {
				foreach($users as $userKey => $loggedUser);
			}

			// [1] Check if project exists
			if(is_array($projects) AND count($projects) == 1 AND is_object($loggedUser)) {
				foreach($projects as $projectKey => $project) {

					// [2] Check current default project
					if($project->id != $loggedUser->defaultProject) {

						// [3] Check if user is in this project
						if($delegate->checkUserInProject($loggedUser->id, $project->id) > 0) {

							// [4] Check if project is open
							if($project->status == PROJECT_STATUS_OPEN) {

								// If default project was saved
								if($delegate->updateUserDefaultProject($loggedUser->id, $project->id)) {

									// Remove default task
									$delegate->updateUserDefaultTask($loggedUser->id, 'NULL');

									$_SESSION['messages'][] = 'Default project successfully saved!';

									// If default project wasn't saved
								} else {
									$_SESSION['errors'][] = "Can't save that project as default!";
								}

							} else {
								$_SESSION['errors'][] = "That project is closed! Can't be saved as default!";
							}

							// If user isn't in that project
						} else {
							$_SESSION['errors'][] = "Project don't exist!";
						}

						// Is user already have this project as default
					} else {
						$_SESSION['errors'][] = 'That is already your default project!';
					}
				}
			}

			// If project id isn't numeric
		} else {
			$_SESSION['errors'][] = "Project don't exist!";
		}

		return goToProjects();

		// If user isn't admin
	} else {
		return goToUserLoginPage();
	}
}


###################################################################################################
###   REPORTS   ###################################################################################


/**
 * Redirect to reports page
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008 
 */
function goToReports() {
	header('Location: ' . SERVER_ROOT . '/reports/reports.php');
	exit ();
}



/**
 * Redirect to general reports
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function goToGeneralReports() {
	header('Location: ' . SERVER_ROOT . '/reports/general-reports.php');
	exit ();
}



/**
 * Redirect to employee reports
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function goToEmployeeReports() {
	header('Location: ' . SERVER_ROOT . '/reports/employee-reports.php');
	exit ();
}



/**
 * Redirect to project reports
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function goToProjectReports() {
	header('Location: ' . SERVER_ROOT . '/reports/project-reports.php');
	exit ();
}



/**
 * Redirect to client reports
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008 
 */
function goToClientReports() {
	header('Location: ' . SERVER_ROOT . '/reports/client-reports.php');
	exit ();
}



/**
 * Display project reports
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008
 */
function doDisplayProjectReportExe() {

	// Collect data
	$projectId	= $_POST['projectId'];
	$userId		= $_POST['angajatId'];
	$startDate	= $_POST['periodStart'];
	$endDate	= $_POST['periodEnd'];
	$errors		= false;

	$tmpProjectReports				= new ProjectReports();
	$tmpProjectReports->projectId	= $projectId;
	$tmpProjectReports->userId		= $userId;
	$tmpProjectReports->startDate	= $startDate;
	$tmpProjectReports->endDate		= $endDate;
	$_SESSION['tmpProjectReports']	= $tmpProjectReports;

	list($startDateDay, $startDateMonth, $startDateYear) = explode('/', $startDate);
	$startDate = $startDateYear . '-' . $startDateMonth . '-' . $startDateDay;

	list($endDateDay, $endDateMonth, $endDateYear) = explode('/', $endDate);
	$endDate = $endDateYear . '-' . $endDateMonth . '-' . $endDateDay;

	// Check project id
	if(!is_numeric($projectId)) {
		$_SESSION['errors'][] = 'Please select a project!';
		$errors = true;
	}

	// Check start and end date
	if(!is_numeric(strtotime($startDate)) OR !is_numeric(strtotime($endDate))) {
		$_SESSION['errors'][] = 'Please select a period of time!';
		$errors = true;
	}

	// Check if start date is higher than end date
	if(strtotime($startDate) > strtotime($endDate)) {
		$_SESSION['errors'][] = 'End date should be higher than start date!';
		$errors = true;
	}

	// Check for errors
	if($errors) {
		return goToProjectReports();

	} else {
		$_SESSION['projectReports']['projectId'] = $projectId;
		$_SESSION['projectReports']['userId'] = $userId;
		$_SESSION['projectReports']['startDate'] = $startDate;
		$_SESSION['projectReports']['endDate'] = $endDate;

		return goToProjectReports();
	}
}



/**
 * General reports
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function doShowGeneralReportsExe() {

	// Collect data	
	$periodTimeStart	= trim($_POST['periodStart']);
	$periodTimeEnd		= trim($_POST['periodEnd']);

	$tmpGeneralReports				= new GeneralReports();
	$tmpGeneralReports->startDate	= $periodTimeStart;
	$tmpGeneralReports->endDate		= $periodTimeEnd;
	$_SESSION['tmpGeneralReports']	= $tmpGeneralReports;

	// TM
	list($startTimeDay, $startTimeMonth, $startTimeYear) = explode('/', $periodTimeStart);
	list($endTimeDay, $endTimeMonth, $endTimeYear) = explode('/', $periodTimeEnd);

	// Convert data to "YYYY-MM-DD"
	$startTime	= $startTimeYear . '-' . $startTimeMonth . '-' . $startTimeDay;
	$endTime	= $endTimeYear . '-' . $endTimeMonth . '-' . $endTimeDay;

	if(strtotime($startTime) > strtotime($endTime)) {
		$_SESSION['errors'][] = 'End date should be higher than start date!';
		return goToGeneralReports();
	}

	// Check the date time start and end
	if(checkReportDate($periodTimeStart) AND checkReportDate($periodTimeEnd)) {
		$_SESSION['generalReports']['start'] = $periodTimeStart;
		$_SESSION['generalReports']['end'] = $periodTimeEnd;

		return goToGeneralReports();

	// If errors
	} else {
		$_SESSION['errors'][] = 'Bad date!';
		unset($_SESSION['generalReports']['start']);
		unset($_SESSION['generalReports']['end']);
		return goToGeneralReports();
	}
}



/**
 * Display employee reports
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008 
 */
function doDisplayEmployeeReportExe() {

	// Collect data
	$userId		= $_POST['employeeId'];
	$projectId	= $_POST['projectId'];
	$startTime	= trim($_POST['periodStart']);
	$endTime	= trim($_POST['periodEnd']);
	$errors		= false;

	$tmpEmployeesReports				= new EmployeesReports();
	$tmpEmployeesReports->userId		= $userId;
	$tmpEmployeesReports->projectId		= $projectId;
	$tmpEmployeesReports->periodOfTime	= null;
	$tmpEmployeesReports->startDate		= $startTime;
	$tmpEmployeesReports->endDate		= $endTime;
	$_SESSION['tmpEmployeesReports']	= $tmpEmployeesReports;

	list($startTimeDay, $startTimeMonth, $startTimeYear) = explode('/', $startTime);
	list($endTimeDay, $endTimeMonth, $endTimeYear) = explode('/', $endTime);

	// Convert data to "YYYY-MM-DD"
	$startTime = $startTimeYear . '-' . $startTimeMonth . '-' . $startTimeDay;
	$endTime = $endTimeYear . '-' . $endTimeMonth . '-' . $endTimeDay;

	// Check user id
	if(!is_numeric($userId) OR $userId <= 0) {
		$_SESSION['errors'][] = 'Please select an user!';
		$errors = true;
	}

	// Check start and end time
	if(!strtotime($startTime) AND !strtotime($endTime)) {
		$_SESSION['errors'][] = 'Please select a period of time!';
		$errors = true;
	}

	// Check start date and end date
	if(strtotime($startTime) > strtotime($endTime)) {
		$_SESSION['errors'][] = 'End date should be higher than start date!';
		$errors = true;
	}

	// If errors
	if($errors == true) {
		return goToEmployeeReports();

	// If no errors	
	} else {
		$_SESSION['employeesReports']['userId']		= $userId;
		$_SESSION['employeesReports']['projectId']	= $projectId;
		$_SESSION['employeesReports']['startTime']	= $startTime;
		$_SESSION['employeesReports']['endTime']	= $endTime;

		return goToEmployeeReports();
	}
}



/**
 * Display client reports
 * 
 * @author	Liviu
 * @since 	Apr 10, 2008
 */
function doDisplayClientReportExe() {

	// Collect data
	$clientId	= $_POST['clientId'];
	$projectId	= $_POST['projectId'];
	$startDate	= trim($_POST['periodStart']);
	$endDate	= trim($_POST['periodEnd']);
	$errors		= false;

	$tmpClientReports				= new ClientReports();
	$tmpClientReports->clientId		= $clientId;
	$tmpClientReports->projectId	= $projectId;
	$tmpClientReports->startDate	= $startDate;
	$tmpClientReports->endDate		= $endDate;
	$_SESSION['tmpClientReports']	= $tmpClientReports;

	list($startTimeDay, $startTimeMonth, $startTimeYear) = explode('/', $startDate);
	list($endTimeDay, $endTimeMonth, $endTimeYear) = explode('/', $endDate);

	// Convert data to "YYYY-MM-DD"
	$startDate = $startTimeYear . '-' . $startTimeMonth . '-' . $startTimeDay;
	$endDate = $endTimeYear . '-' . $endTimeMonth . '-' . $endTimeDay;

	// Check client id
	if(!is_numeric($clientId)) {
		$_SESSION['errors'][] = 'Please select a client!';
		$errors = true;
	}

	// Check start and end time
	if(!strtotime($startDate) AND !strtotime($endDate)) {
		$_SESSION['errors'][] = 'Please select a period of time!';
		$errors = true;
	}

	// Check start date and end date
	if(strtotime($startDate) > strtotime($endDate)) {
		$_SESSION['errors'][] = 'End date should be higher than start date!';
		$errors = true;
	}

	// Check for errors
	if($errors) {
		return goToClientReports();

	} else {
		$_SESSION['clientReports']['clientId'] = $clientId;
		$_SESSION['clientReports']['projectId'] = $projectId;
		$_SESSION['clientReports']['startDate'] = $startDate;
		$_SESSION['clientReports']['endDate'] = $endDate;

		return goToClientReports();
	}
}

###################################################################################################
###   TASKS   #####################################################################################

/**
 * Redirect to edit task page
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function goToEditTask($taskId = null) {

	if($taskId == null) {
		$taskId = $_GET['taskId'];
	}

	header('Location: ' . SERVER_ROOT . "/projects/edittask.php?taskId={$taskId}");
	exit ();
}



/**
 * Set default task and default project
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doSetDefaultTaskExe() {

	// Collect data
	$taskId = $_GET['taskId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_USER) {

		// Check if task id is numeric
		if(is_numeric($taskId)) {

			// Get task and user by id
			$tasks = $delegate->getTasks(array('id' => $taskId));
			$users = $delegate->getUsers(array('id' => $_SESSION['userId']));

			// Get user by id	
			if(is_array($users) AND count($users) == 1) {
				foreach($users as $userKey => $loggedUser);
			}

			// [1] Check if task exists
			if(is_array($tasks) AND count($tasks) == 1 AND is_object($loggedUser)) {
				foreach($tasks as $taskKey => $task) {

					// If default task was saved
					if($delegate->updateUserDefaultTask($loggedUser->id, $task->id)) {

						// Check if user default project is the task parrent
						if($loggedUser->defaultProject != $task->projectId) {
							$delegate->updateUserDefaultProject($loggedUser->id, $task->projectId);
						}

						$_SESSION['messages'][] = 'Task successfully set as default!';
						return goToProjects();

					} else {
						$_SESSION['errors'][] = 'Task failed set as default!';
						return goToProjects();
					}
				}

			} else {
				$_SESSION['errors'][] = "Task don't exist!";
				return goToProjects();
			}

		// If task id isn't numeric
		} else {
			$_SESSION['errors'][] = "Task don't exist!";
			return goToProjects();
		}

	// If user isn't logged
	} else {
		return goToUserLoginPage();
	}
}



/**
 * Move task up or down
 * 
 * @author	Liviu
 * @since 	Apr 1, 2008
 */
function doMoveTaskExe() {

	// Collect data
	$direction = $_GET['direction'];
	$taskId = $_GET['taskId'];
	$errors = false;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Get task 
	$tasks = $delegate->getTasks(array('id' => $taskId));
	
	if(count($tasks) > 0) {
		foreach($tasks as $taskKey => $task); // task->id , task->projectId , ...
	}

	// Get tasks number for one project
	$tasksNumber = $delegate->getTaskNumberForProject($task->projectId);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Check data
		/**
		 * Data should be:
		 * 		*	$task->id should be numeric
		 * 		*	$directions should be "up" (+1) or "down" (-1)
		 * 		*	$task should be object
		 * 		*	$taskNumber should be higher or equal with 2
		 */
		if(is_numeric($task->id) AND ($direction == 'up' OR $direction == 'down') AND is_object($task) AND $tasksNumber >= 2) {

			/**
			 * [1] Case 1, if:
			 * 		$tasksNumber == n 
			 * 		$task->order == 1
			 * 		$direction can be only "down" ↓ (current order+1)
			 */
			if($task->order == 1 AND $direction != 'down') {
				$errors = true;
			}

			/**
			 * [2] Case 2, if:
			 * 		$tasksNumber == n
			 * 		$task->order == $tasksNumber
			 * 		$direction can be only "up" ↑ (current order-1)
			 */
			if($task->order == $tasksNumber AND $direction != 'up') {
				$errors = true;
			}

			// If errors
			if($errors) {
				$_SESSION['errors'][] = "That task can't be moved!";

			// If no errors
			} else {

				// If direction is "down" ↓ (+1)
				if($direction == 'down') {

					// [1] Move the lower task UP
					$oldOrder = ($task->order + 1);
					$newOrder = $task->order;

					// If lower task was successfully moved UP
					if($delegate->changeTaskOrder(null, $task->projectId, $oldOrder, $newOrder)) {

						// [2] If current task was successfully moved DOWN
						if($delegate->changeTaskOrder($task->id, $task->projectId, $task->order, ($task->order + 1))) {
							$_SESSION['messages'][] = 'Task successfully moved down!';

						} else {
							$_SESSION['errors'][] = "That task can't be moved!";
						}

					} else {
						$_SESSION['errors'][] = "That task can't be moved!";
					}

				// If direction is "up" ↑ (-1)
				} elseif($direction == 'up') {

					// [1] Move the upper task DOWN
					$oldOrder = ($task->order - 1);
					$newOrder = $task->order;

					if($delegate->changeTaskOrder(null, $task->projectId, $oldOrder, $newOrder)) {

						// [2] If current task was successfully moved UP
						if($delegate->changeTaskOrder($task->id, $task->projectId, $task->order, ($task->order - 1))) {
							$_SESSION['messages'][] = 'Task successfully moved up!';

						} else {
							$_SESSION['errors'][] = "That task can't be moved!";
						}

					} else {
						$_SESSION['errors'][] = "That task can't be moved!";
					}

				}
			}

			// If wrong data
		} else {
			$_SESSION['errors'][] = "That task can't be moved!";
		}

		return goToProjects();

		// If logged user isn't admin
	} else {
		return goToDaily();
	}

}

/**
 * Add new task
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doAddTaskExe() {
	$taskName	= trim($_POST['taskName']);
	$projectId	= trim($_POST['projectId']);
	$errors		= false;

	// Make enw Delegate instance
	$delegate = new Delegate();

	$task = new Task();
	$task->name = $taskName;
	$task->projectId = $projectId;

	// Check the name
	if(empty($taskName)) {
		$_SESSION['errors'][] = 'Empty task name';
		$errors = true;
	}

	// Check if that task name already exists for this project
	if(!empty($taskName) AND count($delegate->getTasks(array('name' => $taskName, 'projectid' => $projectId ))) > 0) {
		$_SESSION['errors'][] = 'That task name already exists for this project!';
		$errors = true;
	}

	// Check the errors
	if($errors) {
		return goToProjects();

		// If no errors
	} else {

		// Get last order
		$lastOrder = $delegate->getLastOrderTaskByProjectId($projectId);

		$task->order = $lastOrder +1;

		// If new task was added
		if($delegate->addTask($task)) {
			$_SESSION['messages'][] = 'Task successfully added!';

		// If not
		} else {
			$_SESSION['errrors'][] = 'Task failed added!';
		}

		return goToProjects();
	}
}



/**
 * Edit task
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doEditTaskExe() {
	$taskId		= trim($_POST['taskId']);
	$taskName	= trim($_POST['taskName']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Make new Task instance
		$task = new Task();
		$task->id = $taskId;
		$task->name = $taskName;
		$task->projectId = $delegate->getProjectIdByTaskId($taskId);

		// Check the id
		if(empty($taskId) OR !is_numeric($taskId)) {
			return goToProjects();
		}

		// Check the name
		if(empty($taskName)) {
			$_SESSION['errors'][] = 'Empty name!';
			return goToEditTask($taskId);
		}

		// Check if that name already exists for this project
		if(count($delegate->getTaskByNameProjectIdAndUnverifiedId($taskName, $task->projectId, $taskId)) > 0) {
			$_SESSION['errors'][] = 'That task name already exists for this project!';
			return goToEditTask($taskId);
		}

		// If task was updated
		if($delegate->updateTask($task)) {
			$_SESSION['messages'][] = 'Task successfully updated!';
			return goToProjects();

			// If not
		} else {
			$_SESSION['errors'][] = 'Task failed updated!';
			return goToEditTask($taskId);
		}

		// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Delete task by id
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doDeleteTaskByIdExe() {

	// Collect data
	$taskId = intval($_GET['taskId']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// If task id is numeric
		if(is_numeric($taskId)) {

			// Get project id for task
			$projectId = $delegate->getProjectIdByTaskId($taskId);

			// Get task order
			$taskOrder = $delegate->getTaskOrderByTaskId($taskId);

			// If task was deleted
			if($delegate->deleteTaskById($taskId)) {

				// Decrese higher order than deleted task order
				$delegate->decreseTasksOrder($projectId, $taskOrder);

				// Set default task on null for all users who have that task as default
				$delegate->updateUsersDefaultTaskAsNull($taskId);

				$_SESSION['messages'][] = 'Task successfully deleted!';

			// If not
			} else {
				$_SESSION['errors'][] = 'Task failed deleted!';
			}

			return goToProjects();

		// If task id isn't numeric	
		} else {
			$_SESSION['errors'][] = "Task don't exits!";
			return goToProjects();
		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}


###################################################################################################
###   USERS   #####################################################################################


/**
 * Redirect to users page
 * 
 * @author	Liviu
 * @since	Mar 27, 2008
 */
function goToUsers() {
	header('Location: ' . SERVER_ROOT . '/users/users.php');
	exit ();
}



/**
 * Redirect to edit user
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function goToEditUser($userId = null) {

	if($userId == null) {
		$userId = $_GET['userId'];
	}

	header('Location: ' . SERVER_ROOT . "/users/edituser.php?userId={$userId}");
	exit ();
}



/**
 * Add new user
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function addUserExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		$email		= trim($_POST['userEmail']);
		$name		= trim($_POST['userName']);
		$password	= trim($_POST['userPassword']);
		$level		= (trim($_POST['isAdmin'] == 'on')) ? USER_LEVEL_ADMIN : USER_LEVEL_USER;
		$errors		= false;

		// Make new user object
		$newUser			= new User();
		$newUser->name		= $name;
		$newUser->email		= $email;
		$newUser->password	= $password;
		$newUser->level		= $level;

		// Save this object in session
		$_SESSION['newUser'] = $newUser;

		// Get all employees from DB
		$users = $delegate->getUsers();

		// Load and parse license as array()
		$licenseArrayContent = loadKey();

		// Check maxim number of employees
		if(is_numeric($licenseArrayContent['MAX_EMPLOYEERS']) AND $licenseArrayContent['MAX_EMPLOYEERS'] > 0 AND count($users) >= $licenseArrayContent['MAX_EMPLOYEERS']) {
			$_SESSION['errors'][] = 'You have reached maximum users number!';
			return goToUsers();
		}

		// Check the email
		if(empty($email)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty email';
		}

		if(!empty($email) AND checkEmailSyntax($email) == false) {
			$errors = true;
			$_SESSION['errors'][] = 'Bad email syntax';
		}

		// Check it that email already exists
		if(count($delegate->getUsers(array('email' => $email))) > 0) {
			$errors = true;
			$_SESSION['errors'][] = 'That email is already in use by other user!';
		}

		// Check the name
		if(empty($name)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty name';
		}

		// Check the password
		if(empty($password)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty password';
		}

		// If errors
		if($errors) {
			return goToUsers();

		// If no erros
		} else {

			// If user was added
			if($delegate->addUser($newUser)) {
				unset($_SESSION['newUser']);
				$_SESSION['messages'][] = 'User successfully added!';

			// If not
			} else {
				$_SESSION['errors'][] = 'User failed added. Try again!';
			}

			return goToUsers();

		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Change user status by him id
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function doChangeUserStatusExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Check if logged user is admin 
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Get data
		$userId = $_GET['userId'];

		// If user id is numeric
		if(is_numeric($userId)) {

			// Get user by id
			$users = $delegate->getUsers(array('id' => $userId));
			
			foreach($users as $user);

			// If user isn't same logged user
			if($user->id != $_SESSION['userId']) {

				// If user is super admin (LEVEL 3)
				if($loggedUser->level == USER_LEVEL_SUPERADMIN) {

					// If current user status is active, change him to inactive
					if($user->status == USER_STATUS_ACTIVE) {
						if($delegate->changeUserStatus($user->id, USER_STATUS_INACTIVE)) {
							$_SESSION['messages'][] = "Status changed for {$user->name}";
						} else {
							$_SESSION['errors'][] = "Can't change status for {$user->name}";
						}

					// If current user status is inactive, change him to active
					} else {
						if($delegate->changeUserStatus($user->id, USER_STATUS_ACTIVE)) {
							$_SESSION['messages'][] = "Status changed for {$user->name}";
						} else {
							$_SESSION['errors'][] = "Can't change status for {$user->name}";
						}
					}

				// If logged user is admin (LEVEL 2)
				} else {

					// If user is LEVEL 1
					if($user->level <= USER_LEVEL_USER) {

						// If current user status is active, change him to inactive
						if($user->status == USER_STATUS_ACTIVE) {
							if($delegate->changeUserStatus($user->id, USER_STATUS_INACTIVE)) {
								$_SESSION['messages'][] = "Status changed for {$user->name}";
							} else {
								$_SESSION['errors'][] = "Can't change status for {$user->name}";
							}

						// If current user status is inactive, change him to active
						} else {
							if($delegate->changeUserStatus($user->id, USER_STATUS_ACTIVE)) {
								$_SESSION['messages'][] = "Status changed for {$user->name}";
							} else {
								$_SESSION['errors'][] = "Can't change status for {$user->name}";
							}
						}

					} else {
						$_SESSION['errors'][] = "You can't activate/deactivate admins!";
					}
				}

			// If user try to change his status
			} else {
				$_SESSION['errors'][] = "You can't activate/deactivate yourself!";
			}

		// If user id isn't numeric
		} else {
			$_SESSION['errors'][] = "User don't exist";
		}

		return goToUsers();

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Update user
 * @param	object
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function doEditUserExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		$email		= trim($_POST['userEmail']);
		$name		= trim($_POST['userName']);
		$password	= trim($_POST['userPassword']);
		$level		= (trim($_POST['isAdmin']) == 'on') ? USER_LEVEL_ADMIN : USER_LEVEL_USER;
		$status		= trim($_POST['userStatus']);
		$id			= $_POST['userId'];
		$errors		= false;

		$usersObject			= new User();
		$usersObject->id		= $id;
		$usersObject->name		= $name;
		$usersObject->email		= $email;
		$usersObject->password	= $password;
		$usersObject->status	= $status;
		$usersObject->level		= $level;

		// Check for email
		if(empty($email)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty email';

		} elseif(!empty($email) AND checkEmailSyntax($email) == false) {
			$errors = true;
			$_SESSION['errors'][] = 'Bad email syntax';
		}

		// Check for name
		if(empty($name)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty name';
		}

		// Check for password
		if(empty($password)) {
			$errors = true;
			$_SESSION['errors'][] = 'Empty password';
		}

		if(count($delegate->getUsersByEmailAndUnverifiedId($email, $id)) > 0) {
			$errors = true;
			$_SESSION['errors'][] = 'That email is already in use by other user!';
		}

		// If errors
		if($errors) {
			return goToEditUser($id);

		// If no errors
		} else {

			if($delegate->updateUser($usersObject)) {
				$_SESSION['messages'][] = 'User successfully modified';
				return goToUsers();

			} else {
				$_SESSION['errors'][] = 'Nothing to update';
				return goToEditUser($id);
			}
		}

	// If logged user isn't admin or super admin
	} else {
		return goToDaily();
	}
}



/**
 * Add user in project
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doAddUserInProjectExe() {
	$userId = $_POST['user'];
	$projectId = $_POST['projectId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin (LEVEL 2 OR 3)
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		if(is_numeric($userId) AND is_numeric($projectId)) {

			if($userId > 0) {
				// Get user in project
				$userInProject = $delegate->checkUserInProject($userId, $projectId);

				// If user isn't in this project
				if($userInProject == 0 OR empty($userInProject)) {

					// If user was added in project
					if($delegate->addUserInProject($userId, $projectId)) {
						$_SESSION['messages'][] = 'User successfully added in project!';

					// If not
					} else {
						$_SESSION['errors'][] = 'User failed added in project!';
					}

					return goToProjects();

				} else {
					$_SESSION['errors'][] = 'That user already exists in this project!';
					return goToProjects();
				}

			} else {
				$_SESSION['errors'][] = 'Please select an user!';
				return goToProjects();
			}

		// If user id or project id isn't numeric
		} else {
			$_SESSION['errors'][] = "User or project don't exists!";
			return goToProjects();
		}

	// If user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Delete user from project
 * 
 * @author	Liviu
 * @since 	Mar 31, 2008
 */
function doDelteUserFromProjectExe() {

	// Collect data
	$userId		= $_GET['userId'];
	$projectId	= $_GET['projectId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin (LEVEL 2 OR 3)
	if($loggedUser->level >= USER_LEVEL_ADMIN) {
		if(is_numeric($userId) AND is_numeric($projectId)) {

			// If user was successfully removed form project
			if($delegate->removeUserFromProject($userId, $projectId)) {

				// Remove user default project by user and project id
				$delegate->updateUserDefaultProjectAsNullByUserAndProjectId($userId, $projectId);

				$_SESSION['messages'][] = 'User successfully remove from project!';

			// If not			
			} else {
				$_SESSION['errors'][] = 'User failed removed from project!';
			}

			return goToProjects();

		} else {
			$_SESSION['errors'][] = "User or project don't exists!";
			return goToProjects();
		}

	// If user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Redirect to change password page
 * 
 * @author	Liviu
 * @since 	Apr 11, 2008
 */
function goToChangePassword() {
	header('Location: ' . SERVER_ROOT . '/changePassword.php');
	exit ();
}



/**
 * Change password
 * 
 * @author	Liviu
 * @since 	Apr 11, 2008
 */
function doChangePasswordExe() {

	// Collect data
	$oldPassword	= trim($_POST['oldPass']);
	$newPassword	= trim($_POST['newPass']);
	$newPassword2	= trim($_POST['newPass2']);
	$errors			= false;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If user is logged in	
	if(is_object($loggedUser)) {

		// Check old password
		if(empty($oldPassword)) {
			$_SESSION['errors'][] = 'Empty old password!';
			$errors = true;
		}

		// Check new password
		if(empty($newPassword) OR empty($newPassword2)) {
			$_SESSION['errors'][] = 'Empty new password!';
			$errors = true;
		}

		// Check new password
		if($newPassword != $newPassword2) {
			$_SESSION['errors'][] = 'Wrong new password!';
			$errors = true;
		}

		// Check old password with the user password
		if(!empty($oldPassword) AND $oldPassword != $loggedUser->password) {
			$_SESSION['errors'][] = 'Wrong old password!';
			$errors = true;
		}

		// Check for errors
		if($errors) {
			return goToChangePassword();

		// If no errors
		} else {

			// If user password was changed
			if($delegate->changeUserPassword($loggedUser->id, $oldPassword, $newPassword)) {
				$_SESSION['messages'][] = 'Password successfully changed!';

			// If not
			} else {
				$_SESSION['errors'][] = 'Password failed changed!';
			}

			return goToChangePassword();
		}

	// If not
	} else {
		return goToUserLoginPage();
	}
}



/**
 * Delete user by id
 * 
 * @author	Liviu
 * @since 	Mar 28, 2008
 */
function doDeleteUserExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin (LEVEL 2 OR 3)
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Get user id from get
		$userId = $_GET['userId'];

		// Check user id
		if(is_numeric($userId)) {

			// If deleted user isn't logged user
			if($userId != $_SESSION['userId']) {

				// If user is super admin (LEVEL 3)
				if($loggedUser->level == USER_LEVEL_SUPERADMIN) {
					if($delegate->deleteUserById($userId)) {
						$_SESSION['messages'][] = 'User successfully deleted!';

					} else {
						$_SESSION['errors'][] = 'User failed deleted!';
					}

				// If user is admin (LEVEL 2)
				} else {

					if($delegate->getUserById($userId)->level <= USER_LEVEL_USER) {
						if($delegate->deleteUserById($userId)) {
							$_SESSION['messages'][] = 'User successfully deleted!';

						} else {
							$_SESSION['errors'][] = 'User failed deleted!';
						}

					} else {
						$_SESSION['errors'][] = "You can't delete admins!";
					}
				}

			// If user try to deletet himself
			} else {
				$_SESSION['errors'][] = "You can't delete yourself!";
			}

		// If not (if errors)
		} else {
			$_SESSION['errors'][] = "That user don't exist!";
		}

		return goToUsers();

	// If user isn't admin
	} else {
		return goToDaily();
	}
}


###################################################################################################
###   CLIENTS   ###################################################################################


/**
 * Redirect to Clients page
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function goToClients() {
	header('Location: ' . SERVER_ROOT . '/clients/clients.php');
	exit ();
}



/**
 * Add new client
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function addClientExe() {
	$name	= $_POST['name'];
	$errors	= false;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Check if user is admin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Check name
		if(empty($name)) {
			$_SESSION['errors'][] = 'Empty client name';
			$errors = true;
		}

		// Check if that name already exists
		if(!empty($name) AND count($delegate->getClients(null, $name)) > 0) {
			$_SESSION['errors'][] = 'That client name already exists!';
			$errors = true;
		}

		// If errors
		if($errors) {
			return goToClients();

		// If no erros
		} else {

			// If client was added
			if($delegate->addNewClient($name, $loggedUser->companyId)) {
				$_SESSION['messages'][] = 'Client successfully added';

			// If not
			} else {
				$_SESSION['errros'][] = 'Failed';
			}

			return goToClients();
		}

	// If user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Delete client
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function doDeleteClientExe() {
	$clientId	= $_GET['clientId'];
	$errors		= false;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Check if logged user is admin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Check if client id is numeric
		if(!is_numeric($clientId)) {
			$_SESSION['errors'][] = "Client don't exist";
			$errors = true;
		}

		// If client don't exists
		if(!is_numeric($delegate->getClient(array('id' => $clientId))->id)) {
			$_SESSION['errors'][] = "Client don't exist";
			$errors = true;
		}

		// If errors
		if($errors) {
			return goToClients();

		// If no errors	
		} else {

			// If client was deleted
			if($delegate->deleteClientById($clientId)) {
				$_SESSION['messages'][] = 'Client successfully deleted';

			// If not			
			} else {
				$_SESSION['erross'][] = 'Delete client failed';
			}

			return goToClients();
		}

	// If user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Redirects to edit client
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function goToEditClient($clientId = null) {

	if($clientId == null) {
		$clientId = $_GET['clientId'];
	}

	if(is_numeric($clientId)) {
		header('Location: ' . SERVER_ROOT . "/clients/editclient.php?clientId={$clientId}");

	} else {
		$_SESSION['errors'][] = "Client don't exist";
		header('Location: ' . SERVER_ROOT . '/clients/clients.php');
	}
	exit ();
}



/**
 * Modify client
 * 
 * @author	Liviu
 * @since 	Mar 27, 2008
 */
function editClientExe() {
	$clientId = $_POST['clientId'];
	$clientName = $_POST['clientName'];
	$errors = false;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// Check if logged user is admin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Check if that name already exists
		if(count($delegate->checkIfClientExists($clientName, $clientId)) > 0) {
			$_SESSION['errors'][] = 'That client name already exists!';
			$errors = true;
		}

		// Check the name
		if(empty($clientName)) {
			$_SESSION['errors'][] = 'Empty client name';
			$errors = true;
		}

		// If errors
		if($errors) {
			return goToEditClient($clientId);

		// If no errors
		} else {

			// If client was modified
			if($delegate->updateClient($clientId, $clientName)) {
				$_SESSION['messages'][] = 'Client successfully modified';
				return goToClients();

			// If not
			} else {
				$_SESSION['errors'][] = 'Nothing to update';
				return goToEditClient($clientId);
			}
		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}


###################################################################################################
###   ENTRIES   ###################################################################################


/**
 * Finish entry
 * 
 * @author	Liviu
 * @since	Apr 4, 2008
 */
function doFinishEntryExe() {

	// Collect data
	$entryId = $_GET['entryId'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// [1] Check user is logged
	if($loggedUser->level >= USER_LEVEL_USER) {

		// [2] If entry id is numeric
		if(is_numeric($entryId)) {

			// Get entries
			$entries = $delegate->getEntries(array('id' => $entryId));

			// [3] If entries returned is array and higher than 0
			if(is_array($entries) AND count($entries) > 0) {

				// For each loop
				foreach($entries as $entryKey => $entry);

				// [4] If that entry belong for logged user
				if($entry->userId == $loggedUser->id) {

					// List date
					//list($entryYear, $entryMonth, $entryDay) = explode("-", $entry->date);

					// [5] If timespan is zero
					if($entry->timeSpan == '0') {

						// [6] If entry date is same with the current date
						if($entry->date == date('Y-m-d')) {

							// [7] If that entry have al least 60 seconds (1 minute)
							if(strtotime(date('H:i:00')) - strtotime($entry->startTime) >= 60) {

								$startTime = strtotime($entry->startTime);
								$endTime = strtotime(date('H:i:00'));
								$timeSpanSeconds = $endTime - $startTime;

								// Get all entries for current date
								$entries = $delegate->getEntries(array('date' => $entry->date));

								// (strtotime($startTime) >= strtotime($entry->startTime) AND strtotime($startTime) < strtotime($entry->endTime)) OR
								// (strtotime($endTime) > strtotime($entry->startTime) AND strtotime($endTime) < strtotime($entry->endTime)) ) {

								// For each oop
								foreach($entries as $entryKey => $entryCheck) {
									if(strtotime($entryCheck->startTime) > strtotime($entry->startTime) AND strtotime($entryCheck->startTime) < strtotime(date('H:i:00'))) {
										$_SESSION['errors'][] = 'Start/End time is overlapping another entry!';
										return goToDaily();
									} else {
										continue;
									}
								}

								$entryObject					= new Entry();
								$entryObject->id				= $entryId;
								$entryObject->endTime			= date('H:i');
								$entryObject->timeSpan			= ($timeSpanSeconds / 60);
								$entryObject->checkEndTime		= date('Y-m-d H:i:s');
								$entryObject->checkEndTimeIp	= $_SERVER['REMOTE_ADDR'];

								// Debug
								if($entryObject->timeSpan < 1) {
									$entryObject->timeSpan = 1;
								}

								################################################################
								// Get all entries for this day
								$entriesForThisDate = $delegate->getEntries(array('date' => $entry->date));
						
								// For each loop
								foreach($entriesForThisDate as $entryKey => $entry) {
									// Increse
									$totalMinutesForThatDate += $entry->timeSpan;
								}
								
								// If all entries is higher than 24H
								if(($totalMinutesForThatDate + $entryObject->timeSpan) >= 1441) {
									$_SESSION['errors'][] = 'All entries for current date are higher than 24 hours.<br />You can add maxim '. repairTimeSpan(floor((1440 - $totalMinutesForThatDate)/60) .':'. (1440 - $totalMinutesForThatDate)%60) .' hour(s) for this date!';
									return goToDaily();
								}
								################################################################
								
								// If entry was finished
								if($delegate->finishEntry($entryObject)) {
									$_SESSION['messages'][] = 'Entry successfully finished!';

								// If not
								} else {
									$_SESSION['errors'][] = 'Entry failed finished!';
								}

								return goToDaily();

							// [7] If that entry don't have al least 60 seconds (1 minute)
							} else {
								$_SESSION['errors'][] = 'End time should be higher than start time!';
								return goToDaily();
							}

						// [6] If entry date isn't same with the current date, redirect to "choice page"
						} else {
							return goToFinishEntry($entryId);
						}

					// [5] If the entry is already finished
					} else {
						$_SESSION['errors'][] = 'That entry is already finished!';
						return goToDaily();
					}

				// [4] If that entry not belong for logged user
				} else {
					$_SESSION['errors'][] = 'Inexistent entry!';
					return goToDaily();
				}

			// If no entries
			} else {
				$_SESSION['errors'][] = 'Inexistent entry!';
				return goToDaily();
			}

		// If entry id isn't numeric
		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToDaily();
		}

	// If user isn't logged
	} else {
		return goToDaily();
	}
}



/**
 * Redirect to finish entry page
 * 
 * @author	Liviu
 * @since 	Apr 4, 2008
 */
function goToFinishEntry($entryId = null) {
	if(!is_numeric($entryId)) {
		$entryId = $_GET['entryId'];
	}

	header('Location: ' . SERVER_ROOT . "/daily/finishentry.php?entryId={$entryId}");
	exit ();
}



/**
 * Finish opened entry
 * 
 * @author	Liviu
 * @since 	Apr 4, 2008
 */
function doCloseEntryExe() {

	// Collect data
	$entryId		= $_POST['entryId'];			// Hidden field
	$date			= $_POST['date'];				// Hidden field
	$startTime		= trim($_POST['startTime']);	// Hidden field
	$endTime		= trim($_POST['endTime']);
	$timeSpan		= intval(((strtotime($endTime)) - (strtotime($startTime))) / 60);
	$checkEndTime	= date('Y-m-d H:i:s');
	$checkEndTimeIp	= $_SERVER['REMOTE_ADDR'];

	// Make new Entry instance
	$entryObject					= new Entry();
	$entryObject->date				= $date;
	$entryObject->id				= $entryId;
	$entryObject->startTime			= $startTime;
	$entryObject->endTime			= $endTime;
	$entryObject->timeSpan			= $timeSpan;
	$entryObject->checkEndTime		= $checkEndTime;
	$entryObject->checkEndTimeIp	= $checkEndTimeIp;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// [1] Check if logged user is admin
	if($loggedUser->level >= USER_LEVEL_USER) {

		// [2] Check entry id
		if(is_numeric($entryId) AND $entryId > 0) {

			// [3] Check if end time is valid date
			if(checkTimeSpan($endTime) == true AND checkTimeSpan($startTime) == true) {

				// [4] Check if end time is higher than start time
				if(strtotime($endTime) > strtotime($startTime) AND $timeSpan > 0) {

					// [5.1] If entry date is lower than current date
					if(strtotime($entryObject->date) < strtotime(date('Y-m-d'))) {

						// [6] If entry was closed
						if($delegate->closeEntry($entryObject)) {

							$_SESSION['messages'][] = 'Entry successfully closed!';

							// Set up the callendar dates
							$_SESSION['calendarYear']	= date('Y');
							$_SESSION['calendarMonth']	= date('m');
							$_SESSION['calendarDay']	= date('j');

							return goToDaily();

						// [6]
						} else {
							$_SESSION['errors'][] = 'Entry failed closed!';
							return goToFinishEntry($entryId);
						}

					// [5.2] If entry date is equal or higher than current date
					} else {

						// [6] Check if end time is higher than NOW()
						if(strtotime($endTime) < time('H:i')) {

							################################################################
							// Get all entries for this day
							$entriesForThisDate = $delegate->getEntries(array('date' => $entryObject->date));
					
							// For each loop
							foreach($entriesForThisDate as $entryKey => $entry) {
								// Increse
								$totalMinutesForThatDate += $entry->timeSpan;
							}
							
							// If all entries is higher than 24H
							if(($totalMinutesForThatDate + $entryObject->timeSpan) >= 1441) {
								$_SESSION['errors'][] = 'All entries for current date are higher than 24 hours.<br />You can add maxim '. repairTimeSpan(floor((1440 - $totalMinutesForThatDate)/60) .':'. (1440 - $totalMinutesForThatDate)%60) .' hour(s) for this date!';
								return goToFinishEntry($entryId);
							}
							################################################################
								
							// [7] If entry was closed
							if($delegate->closeEntry($entryObject)) {

								$_SESSION['messages'][] = 'Entry successfully closed!';

								// Set up the callendar dates
								$_SESSION['calendarYear']	= date('Y');
								$_SESSION['calendarMonth']	= date('m');
								$_SESSION['calendarDay']	= date('j');

								return goToDaily();

							// [7]
							} else {
								$_SESSION['errors'][] = 'Entry failed closed!';
								return goToFinishEntry($entryId);
							}

						// [6]
						} else {
							$_SESSION['errors'][] = 'Finished time should be higher than current time!';
							return goToFinishEntry($entryId);
						}
					} // end 5.2

				// [4]
				} else {
					$_SESSION['errors'][] = 'Finished time should be higher than start time!';
					return goToFinishEntry($entryId);
				}

			// [3]	
			} else {
				$_SESSION['errors'][] = 'Invalid "Finished" time';
				return goToFinishEntry($entryId);
			}

		// [2]
		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToDaily();
		}

	// [1] If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Redirect to change entry status
 * 
 * @author	Liviu
 * @since 	Apr 18, 2008
 */
function goToChangeEntryStatus($entryId = null, $userId = null, $projectId = null, $startTime = null, $endTime = null) {

	// Collect data
	if($entryId == null) {
		$entryId = $_GET['entryId'];
	}

	$newStatus = $_REQUEST['newStatus'];

	if($userId == null) {
		$userId = $_GET['userId'];
	}

	if($projectId == null) {
		$projectId = $_GET['projectId'];
	}

	if($startTime == null) {
		$startTime = $_GET['startDate'];
	}

	if($endTime == null) {
		$endTime = $_GET['endDate'];
	}

	$_SESSION['employeesReports']['userId'] = $userId;
	$_SESSION['employeesReports']['projectId'] = $projectId;
	$_SESSION['employeesReports']['startTime'] = $startTime;
	$_SESSION['employeesReports']['endTime'] = $endTime;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// [1] Check if logged user is admin
	if($newStatus == 'approved' AND $loggedUser->level >= USER_LEVEL_ADMIN) {

		// Get entries by id
		$entries = $delegate->getEntries(array('id' => $entryId));

		// [2] If entry exists
		if(count($entries) == 1) {

			// For each loop
			foreach($entries as $entryKey => $entry);

			if($entry->status != ENTRY_STATUS_REJECTED) {
				$newEntryStatus = ENTRY_STATUS_REJECTED;
			} else {
				$newEntryStatus = ENTRY_STATUS_APPROVED;
			}

			if($delegate->changeEntryStatus($entryId, $newEntryStatus)) {
				$_SESSION['messages'][] = 'Entry status successfully modified!';
			} else {
				$_SESSION['errors'][] = 'Entry status failed modified!';
			}

			return goToEmployeeReports();

		// [2]
		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToEmployeeReports();
		}

	// [1] If logged user isn't admin
	}

	header('Location: ' . SERVER_ROOT . '/reports/rejectEntry.php?entryId=' . $entryId . '');
	exit();
}



/**
 * Change entry status from/to rejected by id
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008
 */
function doChangeEntryStatusExe() {

	// Collect data
	$entryId	= $_REQUEST['entryId'];
	$reason		= $_REQUEST['reason'];
	$newStatus	= $_REQUEST['newStatus'];

	$userId		= $_REQUEST['userId'];
	$projectId	= $_REQUEST['projectId'];
	$startDate	= $_REQUEST['startDate'];
	$endDate	= $_REQUEST['endDate'];

	$_SESSION['employeesReports']['userId']		= $userId;
	$_SESSION['employeesReports']['projectId']	= $projectId;
	$_SESSION['employeesReports']['startTime']	= $startDate;
	$_SESSION['employeesReports']['endTime']	= $endDate;

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// [1] Check if logged user is admin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		/*
			// Check reason
			if(empty($reason)) {
				$_SESSION['errors'][] = "Empty reason!";
				return goToChangeEntryStatus($entryId, $userId, $projectId, $startDate, $endDate);	
			}	
		*/

		// Get entries by id
		$entries = $delegate->getEntries(array('id' => $entryId));

		// [2] If entry exists
		if(count($entries) == 1) {

			// For each loop
			foreach($entries as $entryKey => $entry);

			if($entry->status != ENTRY_STATUS_REJECTED) {
				$newEntryStatus = ENTRY_STATUS_REJECTED;
			} else {
				$newEntryStatus = ENTRY_STATUS_APPROVED;
			}

			if($delegate->changeEntryStatus($entryId, $newEntryStatus, $reason)) {
				$_SESSION['messages'][] = 'Entry status successfully modified!';
			} else {
				$_SESSION['errors'][] = 'Entry status failed modified!';
			}

			return goToEmployeeReports();

		// [2]
		} else {
			$_SESSION['errors'][] = 'Inexistent entry!';
			return goToEmployeeReports();
		}

	// [1] If logged user isn't admin
	} else {
		return goToDaily();
	}
}

###################################################################################################
###   JAVA CLIENT METHODS   #######################################################################

/**
 * Loghin user
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function clientDoLoginExe() {
	$email = addslashes(trim($_GET['email']));
	$pass = addslashes(trim($_GET['pass']));
	$delegate = new Delegate();

	// Get user ID by email and password
	$user = $delegate->getUserByEmailAndPassword($email, $pass);

	if(is_object($user)) {
		print '<status>TRUE</status>';

	} else {
		print '<status>FALSE</status>';
	}
}



/**
 * Get all projects belongiing to a user
 * 
 * @author	Sergiu
 * @since 	Apr 8, 2008
 */
function clientGetUserProjectsExe() {
	header('Content-type: text/plain');

	$user = addslashes($_GET['email']);
	$pass = addslashes($_GET['pass']);

	if(!$user || !$pass) {
		echo '<status>FALSE</status>';
		exit ();
	}

	$delegate = new Delegate();

	// Get user ID by email and password
	$usr = $delegate->getUserByEmailAndPassword($user, $pass);

	if(!$usr->id) {
		echo '<status>FALSE</status>';
		exit ();
	}

	// get all projects for this user
	$projects = $delegate->getProjectForUserId($usr->id);
	$response = '<projects>';

	foreach($projects as $prj) {
		$response .= '<project>';
		$response .= '<name>' . $prj->name . '</name>';
		$response .= '<id>' . $prj->id . '</id>';

		$response .= '<tasks>';

		$tasks = $delegate->getTasks(array (
			"projectid" => $prj->id
		));
		foreach($tasks as $task) {
			$response .= '<task>';
			$response .= '<name>' . $task->name . '</name>';
			$response .= '<id>' . $task->id . '</id>';
			$response .= '</task>';
		}

		$response .= '</tasks>';
		$response .= '</project>';
	}

	$response .= '</projects>';

	echo '<content>';
	echo '<status>TRUE</status>';
	echo $response;
	echo '</content>';
	exit ();
}



/**
 * Add new entry
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008
 */
function __DEPRECATED__clientAddNewEntryExe() {

	// Collect data
	$userEmail = addslashes($_GET['email']);
	$userPass = addslashes($_GET['pass']);
	$projectId = $_GET['projectId'];
	$taskId = $_GET['taskId'];
	$startTime = trim($_GET['startTime']);
	$endTime = trim($_GET['endTime']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get user by email and password
	$user = $delegate->getUserByEmailAndPassword($userEmail, $userPass);

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($user->id);

	$entryObject = new Entry();
	$entryObject->date = date('Y-m-d');
	$entryObject->startTime = $startTime;
	$entryObject->endTime = $endTime;
	$entryObject->checkDate = date('Y-m-d H:i:s');
	$entryObject->checkDateIp = $_SERVER['REMOTE_ADDR'];
	$entryObject->checkStartTime = date('Y-m-d H:i:s');
	$entryObject->checkStartTimeIp = $_SERVER['REMOTE_ADDR'];
	$entryObject->checkEndTime = date('Y-m-d H:i:s');
	$entryObject->checkEndTimeIp = $_SERVER['REMOTE_ADDR'];
	$entryObject->status = ENTRY_STATUS_PENDING;
	$entryObject->statusDate = date('Y-m-d H:i:s');
	$entryObject->projectId = $projectId;
	$entryObject->userId = $loggedUser->id;
	$entryObject->taskId = (is_numeric($taskId)) ? $taskId : 'NULL';

	print '<content>';
	// If start and end time isn't empyt
	if(!empty($startTime) AND !empty($endTime)) {
		$timeSpan = (strtotime($endTime) - strtotime($startTime)) / 60;
		$entryObject->timeSpan = (strtotime($endTime) - strtotime($startTime)) / 60;

		// If empty
	} else {
		$timeSpan = 0;
		$entryObject->timeSpan = 0;
	}

	// [1] Check if user exists and user id is numeric
	if(is_object($user) AND is_numeric($user->id)) {

		// [2] Check if project id is numeric
		if(is_numeric($projectId) AND $projectId > 0) {

			// Get number or count by user id and project id
			$userInProjectCount = $delegate->checkUserInProject($user->id, $projectId);

			// [3] Check if selected project belong for logged user			
			if(is_numeric($userInProjectCount) AND $userInProjectCount > 0) {

				// [4] Check start time
				if(checkTimeSpan($startTime) == true) {

					####################################################################
					###   CASE  / TYPE	1   ############################################

					if(!empty($startTime) AND empty($endTime) AND $timeSpan == 0) {
						$entryObject->type = ENTRY_TYPE_START_ONLY;
						if($delegate->addEntry($entryObject, ENTRY_TYPE_START_ONLY)) {
							echo '<status>TRUE</status>';
							echo '<error>Entry successfully added!</error>';
							echo '</content>';
						} else {
							echo '<status>FALSE</status>';
							echo '<error>Entry failed added!</error>';
							echo '</content>';
						}

						exit ();

						####################################################################
						###   CASE  / TYPE	2   ############################################

					}
					elseif(!empty($startTime) AND !empty($endTime)) {
						$entryObject->type = ENTRY_TYPE_START_AND_FINISH;
						if($delegate->addEntry($entryObject, ENTRY_TYPE_START_AND_FINISH)) {
							echo '<status>TRUE</status>';
							echo '<error>Entry successfully added!</error>';
							echo '</content>';
						} else {
							echo '<status>FALSE</status>';
							echo '<error>Entry failed added!</error>';
							echo '</content>';
						}
						exit ();

						####################################################################
						###   CASE  / TYPE	3   ############################################

					}
					elseif(empty($startTime) AND empty($endTime) AND !empty($timeSpan)) {
						$entryObject->type = ENTRY_TYPE_TIMESPAN;
						if($delegate->addEntry($entryObject, ENTRY_TYPE_TIMESPAN)) {
							echo '<status>TRUE</status>';
							echo '<error>Entry successfully added!</error>';
							echo '</content>';
						} else {
							echo '<status>FALSE</status>';
							echo '<error>Entry failed added!</error>';
							echo '</content>';
						}
					}
					exit ();

					// [4]
				} else {
					echo '<status>FALSE</status>';
					echo '<error>Please complet start time!</error>';
					echo '</content>';
					exit ();
				}

				// [3]
			} else {
				echo '<status>FALSE</status>';
				echo '<error>Inexistent project!</error>';
				echo '</content>';
				exit ();
			}

			// [2]
		} else {
			echo '<status>FALSE</status>';
			echo '<error>Please select a project !</error>';
			echo '</content>';
			exit ();
		}

		// [1]
	} else {
		echo '<status>FALSE</status>';
		echo '<error>Wrong email / password !</error>';
		echo '</content>';
		exit ();
	}
}

/**
 * Start new task entry from JAVA client
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008
 */
function clientStartEntryExe() {

	header('Content-type: text/plain');

	echo '<content>';

	// Collect data
	$userEmail = addslashes($_GET['email']);
	$userPass = addslashes($_GET['pass']);
	$projectId = $_GET['projectId'];
	$taskId = $_GET['taskId'];
	$comment = $_GET['comment'];

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get user by email and password
	$user = $delegate->getUserByEmailAndPassword($userEmail, $userPass);

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($user->id);

	// Make new Object instance	
	$entryObject = new Entry();

	// Populate Object intance
	$entryObject->date = date('Y-m-d');
	$entryObject->startTime = date('H:i') . ':00';
	$entryObject->checkDate = date('Y-m-d H:i:s');
	$entryObject->checkDateIp = $_SERVER['REMOTE_ADDR'];
	$entryObject->checkStartTime = date('Y-m-d H:i:s');
	$entryObject->checkStartTimeIp = $_SERVER['REMOTE_ADDR'];
	$entryObject->status = ENTRY_STATUS_PENDING;
	$entryObject->statusDate = date('Y-m-d H:i:s');
	$entryObject->description = $comment;
	$entryObject->projectId = $projectId;
	$entryObject->userId = $loggedUser->id;
	$entryObject->taskId = (is_numeric($taskId)) ? $taskId : 'NULL';
	$entryObject->timeSpan = 0;

	// [1] Check if user exists and user id is numeric
	if(is_object($user) AND is_numeric($user->id)) {

		// [2] Check if project id is numeric
		if(is_numeric($projectId) AND $projectId > 0) {

			// Get number or count by user id and project id
			$userInProjectCount = $delegate->checkUserInProject($user->id, $projectId);

			// [3] Check if selected project belong for logged user			
			if(is_numeric($userInProjectCount) AND $userInProjectCount > 0) {

				// Get number of unfinished entries
				$unfinishedEntries = $delegate->getUnfinishedEntriesForUser($user->id);

				// [4]
				if($unfinishedEntries == 0 OR $unfinishedEntries == false) {

					####################################################################
					###   CASE  / TYPE	1   ############################################
					/**
					 * We have only start time
					 */

					if(!empty($entryObject->startTime) AND $entryObject->timeSpan == 0) {
						$entryObject->type = ENTRY_TYPE_START_ONLY;
						if($delegate->addEntry($entryObject, ENTRY_TYPE_START_ONLY)) {
							echo '<status>TRUE</status>';

						} else {
							echo '<status>FALSE</status>';
							echo '<error>Entry failed added!</error>';
						}
					} // End case 1

					// [4]
				} else {
					echo '<status>FALSE</status>';
					echo '<error>You have other unfinished entry!</error>';
				}

				// [3]
			} else {
				echo '<status>FALSE</status>';
				echo '<error>Inexistent project!</error>';
			}

			// [2]
		} else {
			echo '<status>FALSE</status>';
			echo '<error>Please select a project !</error>';
		}

		// [1]
	} else {
		echo '<status>FALSE</status>';
		echo '<error>Wrong email / password !</error>';
	}

	echo '</content>';
}

/**
 * Stop opened entry by JAVA client
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008
 */
function clientStopEntryExe() {
	header('Content-type: text/plain');

	echo '<content>';

	// Collect data
	$userEmail = addslashes($_GET['email']);
	$userPass = addslashes($_GET['pass']);
	if(checkTimeSpan($_GET['endTime'])) {
		$endTime = $_GET['endTime'];
	} else {
		$endTime = date('H:i') . ':00';
	}

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get user by email and password
	$user = $delegate->getUserByEmailAndPassword($userEmail, $userPass);
	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($user->id);

	// Get unfinished entry
	$entries = $delegate->getUnfinishedEntriesForUser($loggedUser->id);
	print_r($entries);
	//foreach($entries as $entryKey => $entry);
	$entry = $entries[0];

	// Collect data
	$entryId = $entry->id;
	$endTime = $endTime;
	$timeSpan = intval(((strtotime($endTime)) - (strtotime($entry->startTime))) / 60);
	$checkEndTime = date('Y-m-d H:i:s');
	$checkEndTimeIp = $_SERVER['REMOTE_ADDR'];

	// Make new Entry instance
	$entryObject = new Entry();
	$entryObject->id = $entry->id;
	$entryObject->endTime = $endTime;
	$entryObject->timeSpan = $timeSpan;
	$entryObject->checkEndTime = $checkEndTime;
	$entryObject->checkEndTimeIp = $checkEndTimeIp;

	//print_r($entryObject);
	//exit();
	//if

	// If entry was finished
	if($delegate->finishEntry($entryObject)) {
		echo '<status>TRUE</status>';

		// If not
	} else {
		echo '<status>FALSE</status>';
		echo '<error>Entry failed finished!</error>';
	}

	echo '</content>';
}

/**
 * Check if user have unfinished tasks
 * 
 * @author	Liviu
 * @since 	Apr 9, 2008
 */
function clientCheckUnfinishedTasksExe() {

	header('Content-type: text/plain');

	echo '<content>';

	// Collect data
	$userEmail = addslashes($_GET['email']);
	$userPass = addslashes($_GET['pass']);

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get user by email and password
	$user = $delegate->getUserByEmailAndPassword($userEmail, $userPass);

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($user->id);

	// Get unfinished tasks
	$unfinishedTasks = $delegate->getUnfinishedEntriesForUser($loggedUser->id);

	if($unfinishedTasks == false AND count($unfinishedTasks) > 0) {
		echo '<status>FALSE</status>';

	} else {

		// For each loop
		foreach($unfinishedTasks as $entryKey => $entry);

		echo '<status>TRUE</status>';
		echo "<time>{$entry->date} {$entry->startTime}</time>";

	}
	echo '</content>';
}

###################################################################################################
###   SETTINGS   ##################################################################################

/**
 * Redirect to setings page
 * 
 * @author	Liviu
 * @since 	Apr 11, 2008
 */
function goToSettings() {
	header('Location: ' . SERVER_ROOT . '/settings.php');
	exit ();
}


/**
 * Add new license file
 * 
 * @author	Liviu
 * @since 	Apr 11, 2008
 */
function doAddLicenseFileExe() {

	// Collect data
	$licenseFile = $_FILES['licenseFile'];
	$errors = false;

	if($licenseFile['name'] != 'license.key') {
		$errors = true;
	}

	if(empty($licenseFile['name'])) {
		$_SESSION['errors'][] = 'Empty licence!';
		return goToSettings();
	}

	$licenseArrayContent = @ loadKey($licenseFile['tmp_name']);

	// Check if REG_NAME exists
	if(!array_key_exists('BUYER_NAME', $licenseArrayContent)) {
		$errors = true;
	}

	// Check if EMAIL exists
	if(!array_key_exists('BUYER_EMAIL', $licenseArrayContent)) {
		$errors = true;
	}

	// Check if KEY exists	
	if(!array_key_exists('KEY', $licenseArrayContent)) {
		$errors = true;
	}

	// Check errors
	if($errors) {
		$_SESSION['errors'][] = 'Bad license file!';
		return goToSettings();

		// If no errors, try to upload license file		
	} else {

		// Check if file is ok
		if(@ uploadFile('license.key', $licenseFile, @ dirname(__FILE__) . '/')) {
			$_SESSION['messages'][] = 'License file successfully upload!';

		} else {
			$_SESSION['errors'][] = 'License file failed upload!';
		}

		return goToSettings();
	}
}

/**
 * Change company nane
 * 
 * @author	Liviu
 * @since 	Apr 17, 2008
 */
function doChangeCompanyNameExe() {

	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Collect data
		$companyName = trim($_POST['companyName']);
		$errors = false;

		// Chech company name
		if(empty($companyName)) {
			$_SESSION['errors'][] = 'Empty company name!';
			$errors = true;
		}

		// If errors
		if($errors) {
			return goToSettings();

		// If no errors
		} else {

			// If settings value was successfully modified
			if($delegate->changeSettingsValueByKey('company_name', $companyName)) {
				$_SESSION['messages'][] = 'Company name successfully changed!';

			// If not
			} else {
				$_SESSION['errors'][] = 'Company name failed changed!';
			}

			return goToSettings();
		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}



/**
 * Change first day of week
 * 
 * @author	Liviu
 * @since 	Apr 17, 2008
 */
function doChangeFirstDayOfWeek() {
	// Make new Delegate instance
	$delegate = new Delegate();

	// Get logged user and save him in object
	$loggedUser = $delegate->getUserById($_SESSION['userId']);

	// If logged user is admin or superadmin
	if($loggedUser->level >= USER_LEVEL_ADMIN) {

		// Collect data
		$firstDayOfWeek = trim($_POST['firstDayOfWeek']);
		$errors = false;

		// Chech first day of week name
		if(empty($firstDayOfWeek)) {
			$_SESSION['errors'][] = 'Empty first day of week!';
			$errors = true;
		}

		// If errors
		if($errors) {
			return goToSettings();

			// If no errors
		} else {

			// If settings value was successfully modified
			if($delegate->changeSettingsValueByKey('first_day_of_week', $firstDayOfWeek)) {
				$_SESSION['messages'][] = 'First day of week successfully changed!';

			// If not
			} else {
				$_SESSION['errors'][] = 'First day of week failed changed!';
			}

			return goToSettings();

		}

	// If logged user isn't admin
	} else {
		return goToDaily();
	}
}
?>